import Flutter
import UIKit
import SSZipArchive
import Alamofire
import SwiftyJSON
import Foundation
import SystemConfiguration
import Foundation
import CryptoSwift
import FMDB


public class SwiftEcpSyncPlugin: NSObject, FlutterPlugin, FlutterStreamHandler, BarcodeScannerViewControllerDelegate {
    
    var database: FMDatabase
    
    let documentsPath = NSURL(fileURLWithPath: NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true)[0])
    
    func barcodeScannerViewController(_ controller: UIViewController?, didScanBarcodeWithResult result: String?) {
        //print("didScanBarcodeWithResult")
        //resultResend(result)
        
        //let items:String = result!
        
        returnItems = ["type": "11","Details": result,"progress": "0"] as! [String : String]
        NotificationCenter.default.post(name: notificationName, object: nil)
    }
    
    func barcodeScannerViewController(_ controller: UIViewController?, didFailWithErrorCode errorCode: String?) {
        //print("didFailWithErrorCode")
        //
        if(errorCode == "PERMISSION_NOT_GRANTED"){
            returnItems = ["type": "12","Details": "Permission not granted, Please try again","progress": "0"]
        }else{
            returnItems = ["type": "12","Details": errorCode,"progress": "0"] as! [String : String]
        }
        
        NotificationCenter.default.post(name: notificationName, object: nil)
        //resultResend(errorCode)
    }
    
    
    private var eventSink: FlutterEventSink?
    let notificationName = Notification.Name("plugin_Progress")
    private var argumentsde: [AnyHashable : Any] = [:]
    var dict : Dictionary = Dictionary<String,String>()
    var alamofireManager : Alamofire.SessionManager?
    var zipNameFinal:String = ""
    var returnItems = ["type": "dhaval","Details": "dhaval","progress": "45"]
    var hostVC:UIViewController!
    var hashMap = [String : String]()
    var resultResend:FlutterResult!
    var ZipPassword:String = ""
    var logURL:String = ""
    var logMethod:String = ""
    
    let syncJSON: NSMutableDictionary = NSMutableDictionary()
    let requestJSON: NSMutableDictionary = NSMutableDictionary()
    
    var syncType = ""
    
    public override init() {
        let configuration = URLSessionConfiguration.default
        configuration.timeoutIntervalForRequest = 2700
        configuration.timeoutIntervalForResource = 2700 // seconds
        alamofireManager = Alamofire.SessionManager(configuration: configuration)
        print(documentsPath)
        database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
    }
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "ecp_sync_plugin", binaryMessenger: registrar.messenger())
        let instance = SwiftEcpSyncPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
        
        let chargingChannel = FlutterEventChannel(name: "ecp_sync_plugin_Progress", binaryMessenger: registrar.messenger())
        //chargingChannel.streamHandler = instance
        chargingChannel.setStreamHandler(instance)
        
        instance.hostVC = UIApplication.shared.delegate?.window??.rootViewController
    }
    
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        
        if let arguments = call.arguments {
            // argumentsde = arguments as! [AnyHashable : Any]
            dict = arguments as! Dictionary<String,String>
        }
        
        /*'UserName': UserName,
         'fk_EmpGlCode': fk_EmpGlCode,
         'ClientName': ClientName,
         'imei': imei,
         'version': appVersion,
         'uploadMethod': uploadMethod,
         'urlUpload': urlUpload,
         'databaseName': databaseName,
         'packageName': packageName*/
        
        //result("iOS \(String(describing: args))" + UIDevice.current.systemVersion)
        if(call.method == "syncronizeData"){
            syncJSON.removeAllObjects()
            requestJSON.removeAllObjects()
            
            self.syncType = "D"
            let UserName : String = dict["UserName"] ?? ""
            let fk_EmpGlCode : String = dict["fk_EmpGlCode"] ?? ""
            let ClientName : String = dict["ClientName"] ?? ""
            let imei : String = dict["imei"] ?? ""
            let version : String = dict["version"] ?? ""
            let uploadMethod : String = dict["uploadMethod"] ?? ""
            logUploadMethod = dict["urlUpload"] ?? ""
            let databaseName : String = dict["databaseName"] ?? ""
            let packageName : String = dict["packageName"] ?? ""
            let dbPassword : String = dict["dbPassword"] ?? ""
            let isDbEncripted : String = dict["isDbEncripted"] ?? ""
            let methodSyncID : String = dict["methodSyncID"] ?? ""
            ZipPassword = dbPassword;
            //databaseName = "BASF-HK-Database"
            logURL = logUploadMethod
            logMethod = methodSyncID
            print("uploadMethod:\(uploadMethod)")
            print("logUploadMethod:\(methodSyncID)")
            
            //print("UserName:\(String(describing: UserName))")
            //print("fk_EmpGlCode:\(String(describing: fk_EmpGlCode))")
            //print("ClientName:\(String(describing: ClientName))")
            //print("imei:\(String(describing: imei))")
            //print("version:\(String(describing: version))")
            //print("uploadMethod:\(String(describing: uploadMethod))")
            //print("urlUpload:\(String(describing: urlUpload))")
            //print("databaseName:\(String(describing: databaseName))")
            //print("packageName:\(String(describing: packageName))")
            //print("dbPassword:\(String(describing: dbPassword))")
            //print("isDbEncripted:\(String(describing: isDbEncripted))")
            //print("\(String(describing:UserName))")
            returnItems = ["type": "dhaval","Details": "dhaval","progress": "45"]
            NotificationCenter.default.post(name: notificationName, object: nil)
            
            if(packageName == "com.ecubix.basflab"){
                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)
                
                let retval = SyncDataForLAB(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei,uploadMethod:uploadMethod,urlUpload:logUploadMethod,databaseName:databaseName, dbPassword: dbPassword, isDbEncripted: isDbEncripted)
                
                result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
                
            } else {
                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
                
                let retval = SyncData(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei,uploadMethod:uploadMethod,urlUpload:logUploadMethod,databaseName:databaseName, dbPassword: dbPassword, isDbEncripted: isDbEncripted)
                
                result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
            }
            
        }else if(call.method == "encodeData"){
            let details : String = dict["details"] ?? ""
            let key : String = dict["key"] ?? ""
            let iv : String = dict["iv"] ?? ""
            
            //let key = "B4V2A1C@S#S$F"
            //let iv = "0000000000000000"
            //let s = "Vcs@1234"
            let enc = try! details.aesEncrypt1(key: key, iv: iv)
            //print(enc)
            result(enc)
            
            
        }else if(call.method == "decodeData"){
            let details : String = dict["details"] ?? ""
            let key : String = dict["key"] ?? ""
            let iv : String = dict["iv"] ?? ""
            
            do{
                let dec = try details.aesDecrypt1(key: key, iv: iv)
                //print("dec:\(dec)")
                //print("\(details == dec)")
                result(dec)
            }catch let error {
                //print("error:\(error)")
                result("error:\(error)")
            }
            
        }else if(call.method == "scanBarCodes"){
            
            
            let isSingleScan : String = dict["isSingleScan"] ?? ""
            let isPlaySound : String = dict["isPlaySound"] ?? ""
            let isOnFlase : String = dict["isOnFlase"] ?? ""
            let themeColor : String = dict["themeColor"] ?? ""
            let isGoogleVision : String = dict["isGoogleVision"] ?? ""
            let nextBtn : String = dict["nextBtn"] ?? ""
            let scanText : String = dict["scanText"] ?? ""
            
            
            if(isGoogleVision == "true"){
                let storyBoard = UIStoryboard(name: "Main", bundle: nil)
                //OneDQrCodeControllerViewController
                let mainViewController = storyBoard.instantiateViewController(withIdentifier: "OneDQrCodeViewController") as! OneDQrCodeViewController
                //NaviViewController
                
                // mainViewController.navigationBarHidden
                
                mainViewController.delegate = self
                mainViewController.isSingleScan = isSingleScan == "true"
                mainViewController.isPlaySound = isPlaySound == "true"
                mainViewController.isOnFlase = isOnFlase == "true"
                mainViewController.nextBtn = nextBtn
                mainViewController.scanText = scanText
                if(themeColor != ""){
                    mainViewController.themeColor = themeColor
                }
                let navigationController = UINavigationController(rootViewController: mainViewController)
                
                hostVC.present(navigationController, animated: true, completion: nil)
            }else{
                let storyBoard = UIStoryboard(name: "Main", bundle: nil)
                
                let mainViewController = storyBoard.instantiateViewController(withIdentifier: "ViewController") as! ViewController
                //NaviViewController
                
                // mainViewController.navigationBarHidden
                
                mainViewController.delegate = self
                mainViewController.isSingleScan = isSingleScan == "true"
                mainViewController.isPlaySound = isPlaySound == "true"
                mainViewController.isOnFlase = isOnFlase == "true"
                mainViewController.nextBtn = nextBtn
                mainViewController.scanText = scanText
                if(themeColor != ""){
                    mainViewController.themeColor = themeColor
                }
                let navigationController = UINavigationController(rootViewController: mainViewController)
                
                hostVC.present(navigationController, animated: true, completion: nil)
            }
            
            
        }else if(call.method == "UniqueNumber"){
            let retValue = getDeviceUniqueNo()
            result(retValue)
        }else if(call.method == "syncronizeDataFile"){
            syncJSON.removeAllObjects()
            requestJSON.removeAllObjects()
            
            self.syncType = "F"
            // Sagar File Sync ################################################
            
            let UserName : String = dict["UserName"] ?? ""
            let fk_EmpGlCode : String = dict["fk_EmpGlCode"] ?? ""
            let ClientName : String = dict["ClientName"] ?? ""
            let imei : String = dict["imei"] ?? ""
            let version : String = dict["version"] ?? ""
            let uploadMethod : String = dict["uploadMethod"] ?? ""
            logUploadMethod = dict["logUploadMethod"] ?? ""
            let urlUpload : String = dict["urlUpload"] ?? ""
            let databaseName : String = dict["databaseName"] ?? ""
            let packageName : String = dict["packageName"] ?? ""
            let dbPassword : String = dict["dbPassword"] ?? ""
            let isDbEncripted : String = dict["isDbEncripted"] ?? ""
            let methodSyncID : String = dict["methodSyncID"] ?? ""
            ZipPassword = dbPassword;
            //print("UserName:\(String(describing: UserName))")
            //print("fk_EmpGlCode:\(String(describing: fk_EmpGlCode))")
            //print("ClientName:\(String(describing: ClientName))")
            //print("imei:\(String(describing: imei))")
            //print("version:\(String(describing: version))")
            //print("uploadMethod:\(String(describing: uploadMethod))")
            //print("logUploadMethod:\(String(describing: logUploadMethod))")
            //print("urlUpload:\(String(describing: urlUpload))")
            //print("databaseName:\(String(describing: databaseName))")
            //print("packageName:\(String(describing: packageName))")
            
            logURL = urlUpload
            logMethod = methodSyncID
            
            returnItems = ["type": "dhaval","Details": "dhaval","progress": "45"]
            NotificationCenter.default.post(name: notificationName, object: nil)
            
            if(packageName == "com.ecubix.basflab"){
                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)
                
                let retval = FileSyncDataForLAB(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei, uploadMethod:uploadMethod, logUploadMethod:logUploadMethod, urlUpload:urlUpload, databaseName:databaseName,isDbEncripted:isDbEncripted)
                
                result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
                
            } else {
                database = FMDatabase(path: documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
                
                let retval = FileSyncData(userName: UserName,fk_EmpGlCode: fk_EmpGlCode, ClientName:ClientName, version:version, imei:imei, uploadMethod:uploadMethod, logUploadMethod:logUploadMethod, urlUpload:urlUpload, databaseName:databaseName,isDbEncripted:isDbEncripted)
                
                result("iOS \(String(describing: retval)) docPath:\(documentsPath) " + UIDevice.current.systemVersion)
                
            }
        }else if(call.method == "getTimeFromUTC"){
            let date : String = dict["date"] ?? ""
            let formatType : String = dict["format"] ?? ""
            
            let result1 = date.toServerDateUTC().toMyFormatDate(format: formatType)
            result(result1)
        }else if(call.method == "checkInternet"){
            let result1 = Reachability.isConnectedToNetwork()
            if(result1){
                //print("true")
                result("true")
            }else{
                //print("false")
                result("false")
            }
            //result(result1)
        }else if(call.method == "openDateSettings"){
            if #available(iOS 10.0, *) {
                UIApplication.shared.open(URL(string: UIApplicationOpenSettingsURLString)!, options: [:], completionHandler: nil)
                result("true")
            } else {
                // Fallback on earlier versions
                result("false")
            }
            
        }else if(call.method == "checkBarCode"){
            let code : String = dict["code"] ?? ""
            var stringValue : String = code
            //codeScanned = stringValue
            
            
            
            //print("stringValue code: \(stringValue)")
            var isGoing = false
            
            if(stringValue.count <= 14){
                isGoing = true
            }
            
            if(isGoing == false){
                let swiftyString = stringValue.replacingOccurrences(of: "\"", with: "")
                //print("swiftyString:\(swiftyString)")
                let trimmedString = swiftyString.trimmingCharacters(in: .whitespaces)
                //print("trimmedString:\(trimmedString)")
                
                //let group = trimmedString.components(separatedBy: "29")
                //print(group)
                
                var ites:Int = 0
                var finalStr:String = ""
                var groupSaprator:String = ""
                while(ites < trimmedString.count){
                    let firstChar = Array(trimmedString)[ites]
                    //print("char:\(firstChar)")
                    //let asc = trimmedString.index(trimmedString.startIndex, offsetBy: ites)
                    //print(asc)
                    let charAscii = firstChar.ascii
                    if(charAscii != 29){
                        finalStr = finalStr + "\(firstChar)"
                    }else{
                        finalStr = finalStr + "\(firstChar)"
                        groupSaprator = "\(firstChar)"
                    }
                    
                    ites = ites + 1
                }
                
                if(!finalStr.isEmpty){
                    if(!groupSaprator.isEmpty){
                        let group = finalStr.components(separatedBy: groupSaprator)
                        //print(group)
                        //print(group[0])
                        //print(group[1])
                        
                        var str1:String = group[group.count - 1]
                        //print(str1)
                        if(!str1.isEmpty){
                            //let str2 = str1.removeAtIndex(enhance(str1.startIndex, 1))
                            //let ffStr = str2.removeAtIndex(enhance(str2.startIndex, 1))
                            
                            if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                str1.remove(at: index)
                                //print(str1) // prints "Hello I must be going"
                            }
                            
                            if let index = str1.index(str1.startIndex, offsetBy: 0, limitedBy: str1.endIndex) {
                                str1.remove(at: index)
                                //print(str1) // prints "Hello I must be going"
                            }
                            
                            stringValue = str1
                            //print("stringValue : \(stringValue)")
                        }
                    }
                }
            }
            
            result(stringValue)
        }else{
            result("iOS syncronizeData not found" + UIDevice.current.systemVersion)
        }
    }
    
    
    
    //File Sync Start
    var SyncId: Int = 0
    var userName: String = "", fk_EmpGlCode: String = "", ClientName: String = "", version: String = "", imei: String = "", uploadMethod: String = "", logUploadMethod: String = "", urlUpload: String = ""
    
    func FileSyncData(userName:String, fk_EmpGlCode:String, ClientName:String, version:String, imei:String, uploadMethod:String, logUploadMethod:String, urlUpload:String, databaseName:String,isDbEncripted:String)->String{
       
        //xxx
        requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_START")
 
        self.userName=userName;
        self.fk_EmpGlCode=fk_EmpGlCode;
        self.ClientName=ClientName;
        self.version=version;
        self.imei=imei;
        self.uploadMethod=uploadMethod;
        self.logUploadMethod=logUploadMethod;
        self.urlUpload=urlUpload;
        
        writeLog(key: "FB_SYNC_START", value: "")
        updateProgress(type: 1, message: "progress", min: 1, max: 7)
        
        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""
        
        let date = Date()
        let calendar = Calendar.current
        
        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)
        
        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)
        
        let fileManager = FileManager.default
        
        let filePathSyncBackUp = documentsPath.appendingPathComponent("SyncBackup")
        let filePathSyncDownload = documentsPath.appendingPathComponent("SyncDownload")
        
        let dateString = String(format: "%02ld%02ld%ld_%02ld%02ld%02ld", day, month, year, hour, minute, second)
        
        //let fName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(version)"
        let fName = "\(dateString)_\(version)"
        let fileMainDir = filePathSyncBackUp?.appendingPathComponent("\(day)/\(fName)")
        let zipName = "\(fName).zip"
        let filePathSyncDownloadZip = filePathSyncDownload!.appendingPathComponent(fName)
        let fileMainDirZip = filePathSyncBackUp?.appendingPathComponent("\(day)/\(zipName)")
        
        let dirCDPD = fileMainDir?.appendingPathComponent("CCDPD")
        let dirCRPD = fileMainDir?.appendingPathComponent("CCRPD")
        let dirCCSD = fileMainDir?.appendingPathComponent("CCSD")
        let dirCCSDR = fileMainDir?.appendingPathComponent("CCSDR")
        let dirCSD = fileMainDir?.appendingPathComponent("CPM_Sticker_Details")
        let dirCPM = fileMainDir?.appendingPathComponent("CPM")
        
        
        if(!deleteDir(path: filePathSyncBackUp! as NSURL)){
            isGoahead = false;
            isGoaheadMessage = "error:101";
        }
        
        DispatchQueue.global(qos: .background).async {
            
            self.deleteDirNew(path: filePathSyncDownload! as NSURL)
            self.createDir(path: filePathSyncBackUp! as NSURL)
            self.createDir(path: filePathSyncDownload! as NSURL)
            self.createDir(path: fileMainDir! as NSURL)
            self.createDir(path: dirCDPD! as NSURL)
            self.createDir(path: dirCRPD! as NSURL)
            self.createDir(path: dirCCSD! as NSURL)
            self.createDir(path: dirCCSDR! as NSURL)
            self.createDir(path: dirCSD! as NSURL)
            self.createDir(path: dirCPM! as NSURL)
            
            self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_START")
            self.syncJSON.setValue("---Export Database Start---", forKey: "1")
            
            let fileLoginDetails$_1 = "LoginDetails$_1.txt";
            let fileCPM_Customer_Dispatch$_1 = "CPM_Customer_Dispatch$_1.txt";
            //let fileCPM_Customer_Dispatch_Product_Details$_1 = "CPM_Customer_Dispatch_Product_Details$_1.txt";
            let fileCPM_Customer_Receive$_1 = "CPM_Customer_Receive$_1.txt";
            let fileCPM_Customer_Sticker_Scrap$_1 = "CPM_Customer_Sticker_Scrap$_1.txt";
            let fileCPM_Customer_Sticker_Consume$_1 = "CPM_Customer_Sticker_Consume$_1.txt";
            let fileLoginFailAttempt_Details$_1 = "LoginFailAttempt_Details$_1.txt";
            let fileLoginFormDetails$_1 = "LoginFormDetails$_1.txt";
            //let fileCPM_Customer_Receive_Product_Details$_1 = "CPM_Customer_Receive_Product_Details$_1.txt";
            
            /*DispatchQueue.main.async  {
             
             }*/
            
            let jsonLoginDetails = self.getJsonFromTable(database: self.database, tableName: "LoginDetails")
            self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginDetails$_1, sBody: "\(jsonLoginDetails)")
            
            sleep(2)
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 7, max: 10)
            }
            let jsonCPM_Customer_Dispatch = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Dispatch")
            self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Dispatch$_1, sBody: "\(jsonCPM_Customer_Dispatch)")
            
            
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 10, max: 12)
            }
            sleep(2)
            let jsonCPM_Customer_Receive = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Receive")
            self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Receive$_1, sBody: "\(jsonCPM_Customer_Receive)")
            
            sleep(2)
            let jsonCPM_Customer_Sticker_Scrap = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Sticker_Scrap")
            self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Sticker_Scrap$_1, sBody: "\(jsonCPM_Customer_Sticker_Scrap)")
            
            sleep(2)
            let jsonCPM_Customer_Sticker_Consume = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Sticker_Consume")
            self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Sticker_Consume$_1, sBody: "\(jsonCPM_Customer_Sticker_Consume)")
            
            sleep(2)
            let jsonLoginFailAttempt_Details = self.getJsonFromTable(database: self.database, tableName: "LoginFailAttempt_Details")
            self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginFailAttempt_Details$_1, sBody: "\(jsonLoginFailAttempt_Details)")
            
            sleep(2)
            let jsonLoginFormDetails = self.getJsonFromTable(database: self.database, tableName: "LoginFormDetails")
            self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginFormDetails$_1, sBody: "\(jsonLoginFormDetails)")
            
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 12, max: 14)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: "CPM_Customer_Dispatch_Product_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCDPD?.path)!)
            
            
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 15, max: 17)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: "CPM_Customer_Receive_Product_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCRPD?.path)!)
        
            sleep(2)
            self.writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSD?.path)!)
            
            sleep(2)
            
            self.writeTransactionTablesToFile(tableName: "CPM_Customer_Sticker_Damage_Remove", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCCSDR?.path)!)
            
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 17, max: 19)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: "CPM_Sticker_Details", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCSD?.path)!)
            
            sleep(2)
            self.writeTransactionTablesToFile(tableName: "CPM_Pallet_Mst", NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirCPM?.path)!)
            
            sleep(2)
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 19, max: 20)
            }
            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_END")
            self.self.syncJSON.setValue("---Export Database End---", forKey: "2")
            
            self.writeLog(key: "CREATE_ZIP_START", value: "")
           
            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_START")
            self.self.syncJSON.setValue("---Create Zip File Start---", forKey: "3")
            
            var success = false
            
            if(isDbEncripted == "true"){
                // Create ZIP FIle
                success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path,
                                                     withContentsOfDirectory: fileMainDir!.path,
                                                     keepParentDirectory: false,
                                                     compressionLevel: 5,
                                                     password: self.ZipPassword,
                                                     aes: true,
                                                     progressHandler: nil)
                //var success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path, withContentsOfDirectory: fileMainDir!.path)
                if(success){
                    self.writeLog(key: "CREATE_ZIP_END", value: "Success")
                    isGoahead = true
                    
                    self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_END")
                    self.self.syncJSON.setValue("---Create Zip File End---", forKey: "4")
                    
                }else{
                    self.writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
                    isGoahead = false
                    isGoaheadMessage = "Error creating zip"
                    self.self.syncJSON.setValue("---Create Zip File Failed---", forKey: "5")
                }
            }else{
                success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path, withContentsOfDirectory: fileMainDir!.path)
                if(success){
                    self.writeLog(key: "CREATE_ZIP_END", value: "Success")
                    isGoahead = true
                    self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_END")
                    self.self.syncJSON.setValue("---Create Zip File End---", forKey: "6")
                }else{
                    self.writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
                    isGoahead = false
                    isGoaheadMessage = "Error creating zip"
                    self.self.syncJSON.setValue("---Create Zip File Failed---", forKey: "7")
                }
            }
            
            //success = false
            //isGoahead = false
            
            self.self.requestJSON.setValue(zipName, forKey: "CREATE_ZIP_FILE_NAME")
            self.self.syncJSON.setValue("---Crate ZIP File Name---\(zipName)", forKey: "8")
            
            var fileData: NSData? = nil
            var fileData1:String  = ""
            if(success){
                do {
                    self.writeLog(key: "ENCODE_ZIP_START", value: "")
                    var fileSizeValue: UInt64 = 0
                    do {
                        let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: fileMainDirZip!.path)
                        
                        if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                            fileSizeValue = UInt64(fileNumberSize)
                            self.writeLog(key: "UPLOAD_ZIP_SIZE", value: "\(fileSizeValue)")
                            let byteCountFormatter = ByteCountFormatter()
                            byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                            
                            self.self.requestJSON.setValue(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)), forKey: "CREATE_ZIP_SIZE")
                            self.self.syncJSON.setValue("---ZIP Size---\(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))", forKey: "9")
                        }
                    } catch {
                        //print(error.localizedDescription)
                        self.self.syncJSON.setValue("---Encode Zip Failed---", forKey: "10")
                    }
                    
                    try fileData = NSData(contentsOfFile: fileMainDirZip!.path, options: NSData.ReadingOptions.mappedIfSafe)
                    
                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                    self.writeLog(key: "ENCODE_ZIP_END", value: "")
                }
                catch let error as NSError {
                    self.writeLog(key: "ENCODE_ZIP_ERROR", value: "\(error)")
                    //print("Ooops! Something went wrong : \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:104"
                    self.syncJSON.setValue("---Encode Zip Failed---", forKey: "11")
                }
            }
            
            self.updateProgress(type: 1, message: "progress", min: 21, max: 34)
            self.startTimmerDetails(min: 21, max: 34)
            // Call API
            if(isGoahead){
                self.writeLog(key: "UPLOAD_ZIP_START", value: "")
                let web = urlUpload+uploadMethod
                print(web)
                print("FileName \(zipName)")
                print("DeviceId \(imei)")
                print("PersonId \(fk_EmpGlCode)")
                print("Version \(version)")
                print("APIToken \(userName)")
                
                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "UPLOAD_API_CALL_START")
                self.self.syncJSON.setValue("---Upload API call start---", forKey: "12")
                
                self.UploadDatabaseFileZipOld(web:web, fileData1:fileData1, zipName:zipName, action: "FileUpload", fileMainDir: fileMainDir!, fileManager:fileManager, filePathSyncDownload:filePathSyncDownload!, filePathSyncDownloadZip:filePathSyncDownloadZip)
                
                /*let parameters = [
                    "FileArray": "\(fileData1)",
                    "FileName": zipName,
                    "DeviceId": "\(imei)",
                    "PersonId": "\(fk_EmpGlCode)",
                    "Version": "\(version)",
                    "SubModuleName": ClientName,
                    "APIToken": "\(userName)",
                ]
                
                self.writeLog(key: "UPLOAD_ZIP_API_START", value: "")
                self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
                    
                    .responseString { response in
                        print("Success: \(response.result)")
                        print(response)
                        
                        switch response.result {
                        case .success(let jsonData):
                            self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
                            self.updateProgress(type: 1, message: "progress", min: 61, max: 65)
                            print("Success with JSON: \(jsonData)")
                            
                            // delete directory
                            self.deleteDirNew(path: fileMainDir! as NSURL)
                            
                            //print(jsonData)
                            
                            do{
                                let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                                
                                let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]
                                
                                let anyObj = JSON(json)
                                
                                var isValid:String = ""
                                var Message:String = ""
                                var Response:String = ""
                                
                                if anyObj["Status"].exists(){
                                    //print("inside Status")
                                    //let list: Array<JSON> = anyObj["Status"].arrayValue
                                    
                                    isValid =  anyObj["Status"].stringValue
                                    Message =  anyObj["Message"].stringValue
                                    Response =  anyObj["Response"].stringValue
                                }else{
                                    isValid =  anyObj["Status"].stringValue
                                    Message =  anyObj["Message"].stringValue
                                    self.writeLog(key: "SYNC_ERROR", value: Message)
                                }
                                
                                if anyObj["SyncId"].exists(){
                                    self.SyncId = anyObj["SyncId"].intValue
                                }
                                
                                if(isValid == "1"){
                                    self.writeLog(key: "UPLOAD_ZIP_API_SUCCESS", value: "")
                                    if (self.isConnectedToNetwork() == true ){
                                        let destination: DownloadRequest.DownloadFileDestination = { _, _ in
                                            let fileURL = filePathSyncDownload!.appendingPathComponent("\(zipName)")
                                            return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                                        }
                                        
                                        Alamofire.download(Response, to: destination).response { response in
                                            //print(response)
                                            
                                            if response.error == nil, let zipPath = response.destinationURL?.path {
                                                //print(zipPath)
                                                
                                                //var fileSizeValue: UInt64 = 0
                                                
                                                /*do {
                                                 let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: zipPath)
                                                 
                                                 if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                                                 let fileSizeValue = UInt64(fileNumberSize)
                                                 }
                                                 } catch {
                                                 //print(error.localizedDescription)
                                                 }*/
                                                self.stopTimer()
                                                self.updateProgress(type: 1, message: "progress", min: 66, max: 98)
                                                
                                                self.createDir(path: filePathSyncDownloadZip as NSURL)
                                                if(self.unzipFile(zipPath: (filePathSyncDownload?.appendingPathComponent("\(zipName)").path)!, destinationPath: filePathSyncDownloadZip.path)){
                                                    //print("Unzipped")
                                                    //CPM_Sticker_Details/CPM_Sticker_Details$_1.txt
                                                    
                                                    let enumerator = fileManager.enumerator(atPath: filePathSyncDownloadZip.path)
                                                    let filePaths = enumerator?.allObjects as! [String]
                                                    let txtFilePaths = filePaths.filter{$0.contains(".txt")}
                                                    
                                                    self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
                                                    
                                                    if self.database.open()
                                                    {
                                                        let deleteQuery = "DELETE FROM CPM_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                                                        
                                                        let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])
                                                        
                                                        let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])
                                                        
                                                        let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                    }
                                                    
                                                    for txtFilePath in txtFilePaths{
                                                        //print("FilePath \(txtFilePath)")
                                                        let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                        let tableName = fileURL.path.fileName().split(separator: "$")
                                                        //print("tableName \(tableName)")
                                                        
                                                        do {
                                                            
                                                            //DispatchQueue.global(qos: .background).async {
                                                            let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)
                                                            
                                                            let json = JSON.init(parseJSON:stringJSON)
                                                            self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                            isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                            if(!isGoahead){
                                                                //DispatchQueue.main.async {
                                                                isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                break;
                                                                //}
                                                            }
                                                            //}
                                                        }
                                                        catch {
                                                            //print("Error Reading \(txtFilePath)")
                                                            isGoahead = false
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                        }
                                                    }
                                                    
                                                    if(isGoahead){
                                                        self.writeLog(key: "SYNC_DONE", value: "")
                                                        self.updateProgress(type: 3, message: Message, min: 100, max: 100)
                                                    }else{
                                                        self.writeLog(key: "SYNC_FAIL", value: isGoaheadMessage)
                                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 100, max: 100)
                                                    }
                                                }else{
                                                    isGoahead = false
                                                    isGoaheadMessage = "Error in extract zip file"
                                                    self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                }
                                            }else{
                                                isGoahead = false
                                                isGoaheadMessage = "Error in download zip file"
                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                self.updateProgress(type: 2, message: Message, min: 0, max: 0)
                                            }
                                        }
                                    }else{
                                        isGoaheadMessage = "NO_INTERNET"
                                        self.writeLog(key: "UPLOAD_ZIP_END", value: isGoaheadMessage)
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    }
                                }else if(isValid == "2"){
                                    isGoaheadMessage = "Session expired. Please try again";
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }else{
                                    isGoaheadMessage = Message;
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }
                            }catch{
                                isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            }
                        case .failure(let error):
                            //print("Request failed with error: \(error)")
                            let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                            self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        }
                }*/
            }else{
                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
            }
            
        }
        
        return isGoaheadMessage
    }
    
    func UploadDatabaseFileZipOld(web:String, fileData1:String, zipName:String, action:String, fileMainDir:URL, fileManager:FileManager, filePathSyncDownload:URL, filePathSyncDownloadZip:URL) {
        
        var isGoahead = true
        var isGoaheadMessage = ""
        
        let parameters = [
            "FileArray": "\(action == "Process" ? "" : "\(fileData1)")",
            "FileName": zipName,
            "DeviceId": "\(imei)",
            "PersonId": "\(fk_EmpGlCode)",
            "Version": "\(version)",
            "SubModuleName": ClientName,
            "APIToken": "\(userName)",
            
            "Action": "\(action)",
            "JsonData": "{\"Sync_Log\":[\"\(requestJSONInString())\"]}",
            "ExtraFields": "",
            "SyncId": "\(action == "Process" ? "\(self.SyncId)" : "")",
        ]
        
        print("{\"Sync_Log\":[\"\(requestJSONInString())\"]}")
        
        if(action == "Process"){
            print("\(parameters)")
        }
        
        self.writeLog(key: "UPLOAD_ZIP_API_START", value: "")
        self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
            
            .responseString { response in
                print("Success: \(response.result)")
                print(response)
                
                switch response.result {
                case .success(let jsonData):
                    self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
                    print("Success with JSON: \(jsonData)")
                    
                    // delete directory
                    self.deleteDirNew(path: fileMainDir as NSURL)
                    
                    //print(jsonData)
                    
                    do{
                        let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                        
                        let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]
                        
                        let anyObj = JSON(json)
                        
                        var isValid:String = ""
                        var Message:String = ""
                        var Response:String = ""
                        
                        if anyObj["Status"].exists(){
                            isValid =  anyObj["Status"].stringValue
                            Message =  anyObj["Message"].stringValue
                            Response =  anyObj["Response"].stringValue
                        }else{
                            isValid =  anyObj["Status"].stringValue
                            Message =  anyObj["Message"].stringValue
                            self.writeLog(key: "SYNC_ERROR", value: Message)
                        }
                        
                        if anyObj["SyncId"].exists(){
                            self.SyncId = anyObj["SyncId"].intValue
                        }
                        
                        if(isValid == "1"){
                            
                            if(action != "Process") {
                                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "UPLOAD_API_CALL_END")
                                self.self.syncJSON.setValue("---Upload API Call End---", forKey: "14")
                                
                                self.stopTimer()
                                self.updateProgress(type: 1, message: "progress", min: 35, max: 60)
                                self.startTimmerDetails(min: 35, max: 60)
                                
                                self.UploadDatabaseFileZipOld(web:web, fileData1:fileData1, zipName:zipName, action:"Process", fileMainDir:fileMainDir, fileManager:fileManager, filePathSyncDownload:filePathSyncDownload, filePathSyncDownloadZip:filePathSyncDownloadZip)
                                
                                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "PROCESS_API_CALL_START")
                                self.self.syncJSON.setValue("---Process API Call Start---", forKey: "15")
                            }
                            else{
                                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "PROCESS_API_CALL_END")
                                self.self.syncJSON.setValue("---Process API Call End---", forKey: "16")
                                
                                self.writeLog(key: "UPLOAD_ZIP_API_SUCCESS", value: "")
                                if (self.isConnectedToNetwork() == true ){
                                    let destination: DownloadRequest.DownloadFileDestination = { _, _ in
                                        let fileURL = filePathSyncDownload.appendingPathComponent("\(zipName)")
                                        return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                                    }
                                    
                                    self.stopTimer()
                                    self.updateProgress(type: 1, message: "progress", min: 61, max: 75)
                                    self.startTimmerDetails(min: 61, max: 75)
                                    
                                    self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_START")
                                    self.self.syncJSON.setValue("---Download DB Start---", forKey: "17")
                                    
                                    Alamofire.download(Response, to: destination).response { response in
                                        
                                        if response.error == nil, let zipPath = response.destinationURL?.path {
                                            
                                            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_END")
                                            self.self.syncJSON.setValue("---Download DB End---", forKey: "18")
                                            
                                            self.stopTimer()
                                            self.updateProgress(type: 1, message: "progress", min: 75, max: 98)
                                            self.startTimmerDetails(min: 75, max: 98)
                                            
                                            self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "IMPORT_FILE_START")
                                            self.self.syncJSON.setValue("---Import File Start---", forKey: "19")
                                            
                                            self.createDir(path: filePathSyncDownloadZip as NSURL)
                                            if(self.unzipFile(zipPath: (filePathSyncDownload.appendingPathComponent("\(zipName)").path), destinationPath: filePathSyncDownloadZip.path)){
                                                
                                                let enumerator = fileManager.enumerator(atPath: filePathSyncDownloadZip.path)
                                                let filePaths = enumerator?.allObjects as! [String]
                                                let txtFilePaths = filePaths.filter{$0.contains(".txt")}
                                                
                                                self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-HK-Database.db")?.path)
                                                
                                                if self.database.open()
                                                {
                                                    let deleteQuery = "DELETE FROM CPM_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                                                    
                                                    let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                    self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])
                                                    
                                                    let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                    self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])
                                                    
                                                    let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                    self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                }
                                                
                                                for txtFilePath in txtFilePaths{
                                                    let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                    let tableName = fileURL.path.fileName().split(separator: "$")
                                                    
                                                    do {
                                                        let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)
                                                        
                                                        let json = JSON.init(parseJSON:stringJSON)
                                                        self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                        isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                        if(!isGoahead){
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                            break;
                                                        }
                                                    }
                                                    catch {
                                                        isGoahead = false
                                                        isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                        self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                        self.self.syncJSON.setValue("---Import File Failed---\(isGoaheadMessage)", forKey: "20")
                                                    }
                                                }
                                                
                                                self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "IMPORT_FILE_END")
                                                self.self.syncJSON.setValue("---Import File End---", forKey: "21")
                                                
                                                self.stopTimer()
                                                if(isGoahead){
                                                    self.self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_END")
                                                    self.self.syncJSON.setValue("---Sync End---", forKey: "22")
                                                    
                                                    self.writeLog(key: "SYNC_DONE", value: "")
                                                    self.updateProgress(type: 3, message: Message, min: 100, max: 100)
                                                }else{
                                                    self.writeLog(key: "SYNC_FAIL", value: isGoaheadMessage)
                                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 100, max: 100)
                                                    self.self.syncJSON.setValue("---Sync Failed---", forKey: "23")
                                                }
                                            }else{
                                                isGoahead = false
                                                isGoaheadMessage = "Error in extract zip file"
                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                self.self.syncJSON.setValue("---Sync Error---\(isGoaheadMessage)", forKey: "23")
                                            }
                                        }else{
                                            isGoahead = false
                                            isGoaheadMessage = "Error in download zip file"
                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                            self.updateProgress(type: 2, message: Message, min: 0, max: 0)
                                            self.self.syncJSON.setValue("---Sync Error---\(isGoaheadMessage)", forKey: "24")
                                        }
                                    }
                                }else{
                                    isGoaheadMessage = "NO_INTERNET"
                                    self.writeLog(key: "UPLOAD_ZIP_END", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    self.self.syncJSON.setValue("---Sync Error---\(isGoaheadMessage)", forKey: "25")
                                }
                            }
                        }else if(isValid == "2"){
                            isGoaheadMessage = "Session expired. Please try again";
                            self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            
                            if(action == "Process") {
                                self.self.syncJSON.setValue("---Upload API Call Failed---\(isGoaheadMessage)", forKey: "26")
                            }else{
                                self.self.syncJSON.setValue("---Process API Call Failed---\(isGoaheadMessage)", forKey: "27")
                            }
                            
                        }else{
                            isGoaheadMessage = Message;
                            self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        }
                    }catch{
                        isGoaheadMessage = "server error:@, please try again \(jsonData)";
                        self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        
                        if(action == "Process") {
                            self.self.syncJSON.setValue("---Upload API Call Failed---\(isGoaheadMessage)", forKey: "28")
                        }else{
                            self.self.syncJSON.setValue("---Process API Call Failed---\(isGoaheadMessage)", forKey: "29")
                        }
                    }
                case .failure(let error):
                    let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                    self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                    
                    let httpStatusCode = response.response?.statusCode
                    
                    if(action == "Process") {
                        self.self.syncJSON.setValue("---Response Status Not Getting 200---\(httpStatusCode)", forKey: "30")
                        self.self.syncJSON.setValue("---Upload API Call Failed---\(isGoaheadMessage)", forKey: "31")
                    }else{
                        self.self.syncJSON.setValue("---Response Status Not Getting 200---\(httpStatusCode)", forKey: "32")
                        self.self.syncJSON.setValue("---Process API Call Failed---\(isGoaheadMessage)", forKey: "33")
                    }
                }
        }
    }
    
    func FileSyncDataForLAB(userName:String, fk_EmpGlCode:String, ClientName:String, version:String, imei:String, uploadMethod:String, logUploadMethod:String, urlUpload:String, databaseName:String,isDbEncripted:String)->String{
        
        self.userName=userName;
        self.fk_EmpGlCode=fk_EmpGlCode;
        self.ClientName=ClientName;
        self.version=version;
        self.imei=imei;
        self.uploadMethod=uploadMethod;
        self.logUploadMethod=logUploadMethod;
        self.urlUpload=urlUpload;
        
        writeLog(key: "FB_SYNC_START", value: "")
        updateProgress(type: 1, message: "progress", min: 1, max: 7)
        
        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""
        
        let date = Date()
        let calendar = Calendar.current
        
        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)
        
        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)
        
        let fileManager = FileManager.default
        
        let filePathSyncBackUp = documentsPath.appendingPathComponent("SyncBackup")
        let filePathSyncDownload = documentsPath.appendingPathComponent("SyncDownload")
        
        let dateString = String(format: "%02ld%02ld%ld_%02ld%02ld%02ld", day, month, year, hour, minute, second)
        
        //let fName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(version)"
        let fName = "\(dateString)_\(version)"
        let fileMainDir = filePathSyncBackUp?.appendingPathComponent("\(day)/\(fName)")
        let zipName = "\(fName).zip"
        let filePathSyncDownloadZip = filePathSyncDownload!.appendingPathComponent(fName)
        let fileMainDirZip = filePathSyncBackUp?.appendingPathComponent("\(day)/\(zipName)")
        
        let dirLS = fileMainDir?.appendingPathComponent("LS")
        let dirLMA = fileMainDir?.appendingPathComponent("LMA")
        let dirLMR = fileMainDir?.appendingPathComponent("LMR")
        let dirLD = fileMainDir?.appendingPathComponent("LD")
        let dirLSD = fileMainDir?.appendingPathComponent("LSD")
        let dirLCD = fileMainDir?.appendingPathComponent("LCD")
        let dirLCDPD = fileMainDir?.appendingPathComponent("LCDPD")
        
        if(!deleteDir(path: filePathSyncBackUp! as NSURL)){
            isGoahead = false;
            isGoaheadMessage = "error:101";
        }
        
        DispatchQueue.global(qos: .background).async {
            
            self.deleteDirNew(path: filePathSyncDownload! as NSURL)
            self.createDir(path: filePathSyncBackUp! as NSURL)
            self.createDir(path: filePathSyncDownload! as NSURL)
            self.createDir(path: fileMainDir! as NSURL)
            self.createDir(path: dirLS! as NSURL)
            self.createDir(path: dirLMA! as NSURL)
            self.createDir(path: dirLMR! as NSURL)
            self.createDir(path: dirLD! as NSURL)
            self.createDir(path: dirLSD! as NSURL)
            self.createDir(path: dirLCD! as NSURL)
            self.createDir(path: dirLCDPD! as NSURL)
            
            let fileLoginDetails$_1 = "LoginDetails$_1.txt";
            //let fileCPM_Customer_Dispatch$_1 = "CPM_Customer_Dispatch$_1.txt";
            //let fileCPM_Customer_Dispatch_Product_Details$_1 = "CPM_Customer_Dispatch_Product_Details$_1.txt";
            //let fileCPM_Customer_Receive$_1 = "CPM_Customer_Receive$_1.txt";
            //let fileCPM_Customer_Receive_Product_Details$_1 = "CPM_Customer_Receive_Product_Details$_1.txt";
            
            /*DispatchQueue.main.async  {
             
             }*/
            
            let jsonLoginDetails = self.getJsonFromTable(database: self.database, tableName: "LoginDetails")
            self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileLoginDetails$_1, sBody: "\(jsonLoginDetails)")
            
            sleep(2)
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 7, max: 10)
            }
            //let jsonCPM_Customer_Dispatch = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Dispatch")
            //self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Dispatch$_1, sBody: "\(jsonCPM_Customer_Dispatch)")
            
            
            //DispatchQueue.main.async  {
            //    self.updateProgress(type: 1, message: "progress", min: 10, max: 12)
            //}
            //sleep(2)
            //let jsonCPM_Customer_Receive = self.getJsonFromTable(database: self.database, tableName: "CPM_Customer_Receive")
            //self.generateTextFile(root: (fileMainDir?.path)!, sFileName: fileCPM_Customer_Receive$_1, sBody: "\(jsonCPM_Customer_Receive)")
            
            
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 12, max: 15)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_STORE, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLS?.path)!)
            
            
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 15, max: 18)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_MATERIAL_ALLOCATION, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLMA?.path)!)
            
            
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 18, max: 20)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_MATERIAL_RETURN, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLMR?.path)!)
            
            sleep(2)
            
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_DISPOSAL, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLD?.path)!)
            
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 20, max: 22)
            }
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_CUSTOMER_DISPATCH, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLCD?.path)!)
            
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_CUSTOMER_DISPATCH_PRODUCT_DETAILS, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLCDPD?.path)!)
            
            sleep(2)
            self.writeTransactionTablesToFile(tableName: DBHelper.TABLE_LAB_STICKER_DETAILS, NumberOfRecordPerArray: 1000, intRowNumber: 0, filePath: (dirLSD?.path)!)
            
            sleep(2)
            DispatchQueue.main.async  {
                self.updateProgress(type: 1, message: "progress", min: 22, max: 25)
            }
            
            self.writeLog(key: "CREATE_ZIP_START", value: "")
            
            var success = false
            
            if(isDbEncripted == "true"){
                // Create ZIP FIle
                success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path,
                                                     withContentsOfDirectory: fileMainDir!.path,
                                                     keepParentDirectory: false,
                                                     compressionLevel: 5,
                                                     password: self.ZipPassword,
                                                     aes: true,
                                                     progressHandler: nil)
                //var success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path, withContentsOfDirectory: fileMainDir!.path)
                if(success){
                    self.writeLog(key: "CREATE_ZIP_END", value: "Success")
                    isGoahead = true
                }else{
                    self.writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
                    isGoahead = false
                    isGoaheadMessage = "Error creating zip"
                }
            }else{
                success = SSZipArchive.createZipFile(atPath: fileMainDirZip!.path, withContentsOfDirectory: fileMainDir!.path)
                if(success){
                    self.writeLog(key: "CREATE_ZIP_END", value: "Success")
                    isGoahead = true
                }else{
                    self.writeLog(key: "CREATE_ZIP_END", value: "Error creating zip")
                    isGoahead = false
                    isGoaheadMessage = "Error creating zip"
                }
            }
            
            //success = false
            //isGoahead = false
            
            var fileData: NSData? = nil
            var fileData1:String  = ""
            if(success){
                do {
                    self.writeLog(key: "ENCODE_ZIP_START", value: "")
                    var fileSizeValue: UInt64 = 0
                    do {
                        let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: fileMainDirZip!.path)
                        
                        if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                            fileSizeValue = UInt64(fileNumberSize)
                            self.writeLog(key: "UPLOAD_ZIP_SIZE", value: "\(fileSizeValue)")
                            let byteCountFormatter = ByteCountFormatter()
                            byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                        }
                    } catch {
                        //print(error.localizedDescription)
                    }
                    
                    try fileData = NSData(contentsOfFile: fileMainDirZip!.path, options: NSData.ReadingOptions.mappedIfSafe)
                    
                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                    self.writeLog(key: "ENCODE_ZIP_END", value: "")
                }
                catch let error as NSError {
                    self.writeLog(key: "ENCODE_ZIP_ERROR", value: "\(error)")
                    //print("Ooops! Something went wrong : \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:104"
                }
            }
            
            self.updateProgress(type: 1, message: "progress", min: 26, max: 30)
            self.startTimmerDetails(min: 30, max: 60)
            // Call API
            if(isGoahead){
                self.writeLog(key: "UPLOAD_ZIP_START", value: "")
                let web = urlUpload+uploadMethod
                print(web)
                print("FileName \(zipName)")
                print("DeviceId \(imei)")
                print("PersonId \(fk_EmpGlCode)")
                print("Version \(version)")
                print("APIToken \(userName)")
                
                let parameters = [
                    "FileArray": "\(fileData1)",
                    "FileName": zipName,
                    "DeviceId": "\(imei)",
                    "PersonId": "\(fk_EmpGlCode)",
                    "Version": "\(version)",
                    "SubModuleName": ClientName,
                    "APIToken": "\(userName)",
                ]
                
                /*let parameters = [
                 "FileArray": "\(fileData1)",
                 "FileName": zipName,
                 "DeviceId": "000000000000000",
                 "PersonId": "3",
                 "Version": "18.0.11",
                 "SubModuleName": "BASF_HK_Device",
                 "APIToken": "3B6D5CE1-0F9F-468E-A42F-2F4F7EFEF8A8",
                 ]*/
                
                self.writeLog(key: "UPLOAD_ZIP_API_START", value: "")
                self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
                    
                    .responseString { response in
                        print("Success: \(response.result)")
                        print(response)
                        
                        switch response.result {
                        case .success(let jsonData):
                            self.writeLog(key: "UPLOAD_ZIP_END", value: "SUCCESS")
                            self.updateProgress(type: 1, message: "progress", min: 61, max: 65)
                            print("Success with JSON: \(jsonData)")
                            
                            // delete directory
                            self.deleteDirNew(path: fileMainDir! as NSURL)
                            
                            //print(jsonData)
                            
                            do{
                                let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                                
                                let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]
                                
                                let anyObj = JSON(json)
                                
                                var isValid:String = ""
                                var Message:String = ""
                                var Response:String = ""
                                
                                if anyObj["Status"].exists(){
                                    //print("inside Status")
                                    //let list: Array<JSON> = anyObj["Status"].arrayValue
                                    
                                    isValid =  anyObj["Status"].stringValue
                                    Message =  anyObj["Message"].stringValue
                                    Response =  anyObj["Response"].stringValue
                                }else{
                                    isValid =  anyObj["Status"].stringValue
                                    Message =  anyObj["Message"].stringValue
                                    self.writeLog(key: "SYNC_ERROR", value: Message)
                                }
                                
                                if anyObj["SyncId"].exists(){
                                    self.SyncId = anyObj["SyncId"].intValue
                                }
                                
                                if(isValid == "1"){
                                    self.writeLog(key: "UPLOAD_ZIP_API_SUCCESS", value: "")
                                    if (self.isConnectedToNetwork() == true ){
                                        let destination: DownloadRequest.DownloadFileDestination = { _, _ in
                                            let fileURL = filePathSyncDownload!.appendingPathComponent("\(zipName)")
                                            return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
                                        }
                                        
                                        Alamofire.download(Response, to: destination).response { response in
                                            //print(response)
                                            
                                            if response.error == nil, let zipPath = response.destinationURL?.path {
                                                //print(zipPath)
                                                
                                                //var fileSizeValue: UInt64 = 0
                                                
                                                /*do {
                                                 let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: zipPath)
                                                 
                                                 if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                                                 let fileSizeValue = UInt64(fileNumberSize)
                                                 }
                                                 } catch {
                                                 //print(error.localizedDescription)
                                                 }*/
                                                self.stopTimer()
                                                self.updateProgress(type: 1, message: "progress", min: 66, max: 98)
                                                
                                                self.createDir(path: filePathSyncDownloadZip as NSURL)
                                                if(self.unzipFile(zipPath: (filePathSyncDownload?.appendingPathComponent("\(zipName)").path)!, destinationPath: filePathSyncDownloadZip.path)){
                                                    //print("Unzipped")
                                                    //CPM_Sticker_Details/CPM_Sticker_Details$_1.txt
                                                    
                                                    let enumerator = fileManager.enumerator(atPath: filePathSyncDownloadZip.path)
                                                    let filePaths = enumerator?.allObjects as! [String]
                                                    let txtFilePaths = filePaths.filter{$0.contains(".txt")}
                                                    
                                                    self.database = FMDatabase(path: self.documentsPath.appendingPathComponent("BASF-LAB-Database.db")?.path)
                                                    
                                                    if self.database.open()
                                                    {
                                                        let deleteQuery = "DELETE FROM LAB_Customer_Dispatch_Product_Details WHERE chrSync = 'N'"
                                                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                                                        
                                                        //let deleteQuery2 = "DELETE FROM CPM_Customer_Receive_Product_Details WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery2, withArgumentsIn: [])
                                                        
                                                        //let deleteQuery3 = "DELETE FROM CPM_Customer_Sticker_Damage WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery3, withArgumentsIn: [])
                                                        
                                                        //let deleteQuery4 = "DELETE FROM CPM_Customer_Sticker_Damage_Remove WHERE chrSync = 'N'"
                                                        //self.database.executeUpdate(deleteQuery4, withArgumentsIn: [])
                                                    }
                                                    
                                                    for txtFilePath in txtFilePaths{
                                                        //print("FilePath \(txtFilePath)")
                                                        let fileURL = filePathSyncDownloadZip.appendingPathComponent(txtFilePath)
                                                        let tableName = fileURL.path.fileName().split(separator: "$")
                                                        //print("tableName \(tableName)")
                                                        
                                                        do {
                                                            
                                                            //DispatchQueue.global(qos: .background).async {
                                                            let stringJSON = try String(contentsOf: fileURL, encoding: .utf8)
                                                            
                                                            let json = JSON.init(parseJSON:stringJSON)
                                                            self.deleteRecordForViolation(tableName: String(tableName[0]), jsonArray: json)
                                                            isGoahead = self.insertRecordDynamic(tableName: String(tableName[0]), jsonArray: json)
                                                            if(!isGoahead){
                                                                //DispatchQueue.main.async {
                                                                isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                                break;
                                                                //}
                                                            }
                                                            //}
                                                        }
                                                        catch {
                                                            //print("Error Reading \(txtFilePath)")
                                                            isGoahead = false
                                                            isGoaheadMessage = "Response data file not proper, Please re-sync."
                                                            self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                        }
                                                    }
                                                    
                                                    if(isGoahead){
                                                        self.writeLog(key: "SYNC_DONE", value: "")
                                                        self.updateProgress(type: 3, message: Message, min: 100, max: 100)
                                                    }else{
                                                        self.writeLog(key: "SYNC_FAIL", value: isGoaheadMessage)
                                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 100, max: 100)
                                                    }
                                                }else{
                                                    isGoahead = false
                                                    isGoaheadMessage = "Error in extract zip file"
                                                    self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                                }
                                            }else{
                                                isGoahead = false
                                                isGoaheadMessage = "Error in download zip file"
                                                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                                                self.updateProgress(type: 2, message: Message, min: 0, max: 0)
                                            }
                                        }
                                    }else{
                                        isGoaheadMessage = "NO_INTERNET"
                                        self.writeLog(key: "UPLOAD_ZIP_END", value: isGoaheadMessage)
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    }
                                }else if(isValid == "2"){
                                    isGoaheadMessage = "Session expired. Please try again";
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }else{
                                    isGoaheadMessage = Message;
                                    self.writeLog(key: "UPLOAD_ZIP_API_FAIL", value: isGoaheadMessage)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }
                            }catch{
                                isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            }
                        case .failure(let error):
                            //print("Request failed with error: \(error)")
                            let isGoaheadMessage = "# Oops something went wrong, please try again \(error)"
                            self.writeLog(key: "UPLOAD_ZIP_API_ERROR", value: isGoaheadMessage)
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        }
                }
            }else{
                self.writeLog(key: "SYNC_ERROR", value: isGoaheadMessage)
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
            }
            
        }
        
        return isGoaheadMessage
    }
    
    func deleteRecordForViolation(tableName:String, jsonArray:JSON){
        if(jsonArray.count>0){
            var i:Int = 0
            var initGlCodes:String = ""
            while(i < jsonArray.count){
                
                var intGlCode:Int = 0
                if jsonArray[i]["intGlCode"] == nil {
                    intGlCode = 0
                }else{
                    intGlCode = jsonArray[i]["intGlCode"].intValue
                }
                
                if(initGlCodes == ""){
                    initGlCodes = "\(intGlCode)"
                }else{
                    initGlCodes = "\(initGlCodes),\(intGlCode)"
                }
                i = i + 1
            }
            
            print("intGlCode:\(initGlCodes)")
            if(!initGlCodes.isEmpty){
                do{
                    var count:Int = 0
                    let selectQuery:String = "SELECT intGlCode FROM " + tableName + "  WHERE intGlCode IN (" + initGlCodes + ")";
                    if let rs = self.database.executeQuery(selectQuery, withArgumentsIn: []) {
                        while rs.next() {
                            count = Int(rs.int(forColumn: "intGlCode"))
                            print("Total Records:", count)
                        }
                    }
                    
                    if(count > 0){
                        let deleteQuery = "DELETE FROM  " + tableName + "  WHERE intGlCode IN (" + initGlCodes + ")"
                        self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    }
                    
                }catch{
                    print("error deleteRecordForViolation")
                }
            }
            
        }
    }
    
    func insertRecordDynamic(tableName:String, jsonArray:JSON)->Bool{
        
        // DispatchQueue.global(qos: .background).async {
        var success = true
        
        do{
            let isTranTable = (tableName == DBHelper.TABLE_CPM_CUSTOMER_DISPATCH
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_RECEIVE
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE
                || tableName == DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE_REMOVE
                || tableName == DBHelper.TABLE_CPM_Customer_Sticker_Scrap
                || tableName == DBHelper.TABLE_CPM_Customer_Sticker_Consume
                || tableName == DBHelper.TABLE_PERSON_MST
                || tableName == DBHelper.TABLE_CPM_DAMAGE_TYPE
                || tableName == DBHelper.TABLE_PRODUCT_SKU_MST
                || tableName == DBHelper.TABLE_CUSTOMER_PARTNER_MST
                || tableName == DBHelper.TABLE_CUSTOMER_TYPE_COUNTRY_MST
                || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_LEVEL_COUNTRY_MST
                || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_DETAILS
                || tableName == DBHelper.TABLE_CPM_PALLET_MST
                || tableName == DBHelper.TABLE_CPM_STRICKER_Details)
            print(tableName)
            
            /*if(tableName == "CPM_Sticker_Details" || tableName == "Customer_Type_Country_Mst"){
             let deleteQuery = "DELETE FROM \(tableName)"
             self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
             }*/
            
            /*if(tableName != "CPM_Sticker_Details"){
             return true
             }*/
            
            if !isTranTable && self.database.open()
            {
                let deleteQuery = "DELETE FROM \(tableName)"
                self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                //// print("here one")
            }else{
                if (tableName != DBHelper.TABLE_CPM_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                    && tableName != DBHelper.TABLE_CPM_CUSTOMER_RECEIVE_PRODUCT_DETAILS
                    && tableName != DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE
                    && tableName != DBHelper.TABLE_CPM_CUSTOMER_STICKER_DAMAGE_REMOVE) {
                    
                    let deleteQuery = "DELETE FROM \(tableName) WHERE chrSync = 'N'"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                }
                // print("here two")
            }
            
            if(tableName == "CPM_Sticker_Details"){
                return parseJsonStickerDetails(Tourplan_Daily: jsonArray)
                //return true
            }else{
                
                if(jsonArray.count>0){
                    
                    var sbQuery = ""
                    
                    sbQuery = "INSERT INTO \(tableName) ("
                    
                    let keys = jsonArray[0].dictionaryValue.keys
                    
                    var sbQuery2 = ""
                    for (position, name) in keys.enumerated() {
                        if(name=="chrTran"){
                            continue
                        }
                        sbQuery2.append(name)
                        sbQuery2.append(",")
                    }
                    
                    sbQuery2 = sbQuery2.trim()
                    sbQuery2 = String(sbQuery2.dropLast())
                    
                    sbQuery.append(sbQuery2)
                    sbQuery.append(" ) VALUES ")
                    
                    let arraySize = jsonArray.count
                    let BATCHSIZE = 150
                    let intBatch = Int(CGFloat(ceil(Double(Double(arraySize) * 1.00 / Double(BATCHSIZE)))))-1
                    let intRemainder = Int(Double(arraySize).truncatingRemainder(dividingBy: Double(BATCHSIZE)))
                    var intMaxRecords = Int(BATCHSIZE)
                    
                    //print("intBatch:\(intBatch)")
                    //print("intRemainder:\(intRemainder)")
                    //print("intMaxRecords:\(intMaxRecords)")
                    
                    //print("here 1:\(sbQuery)")
                    
                    for b in 0...intBatch {
                        var finalInsert=""
                        finalInsert.append(sbQuery)
                        if (b == intBatch) {
                            intMaxRecords = intRemainder == 0 ? BATCHSIZE : intRemainder;
                        }
                        
                        var valuesBuiler=""
                        var deleteValues = [String]()
                        var deleteQ=""
                        let innerLoopSize = Int((b * Int(BATCHSIZE)) + intMaxRecords)-1
                        let tmp1 = Int((b * BATCHSIZE))
                        
                        //print("BATCHSIZE:\(BATCHSIZE)")
                        //print("innerLoopSize:\(innerLoopSize)")
                        //print("tmp1:\(tmp1)")
                        
                        for m in tmp1...innerLoopSize {
                            //let jsonObject = jsonArray[m]
                            if(jsonArray[m].dictionaryValue.keys.contains("chrTran")){
                                let chrTran = jsonArray[m].dictionaryValue["chrTran"]?.string
                                
                                if (jsonArray[m].dictionaryValue.keys.contains("varSync_Code")) {
                                    deleteQ.append(deleteValues.count <= 0 ? "?" : ",?")
                                    deleteValues.append((jsonArray[m].dictionaryValue["varSync_Code"]?.string)!)
                                }
                                if (chrTran != nil && chrTran!.caseInsensitiveCompare("d") == .orderedSame) {
                                    continue
                                }
                            }
                            
                            if (!valuesBuiler.isEmpty){
                                valuesBuiler.append(",")
                            }
                            
                            valuesBuiler.append("(")
                            
                            for (pos, key) in jsonArray[m].dictionaryValue.keys.enumerated() {
                                let hasNext = (pos != jsonArray[m].dictionaryValue.keys.count-1)
                                if (key=="chrTran") {
                                    if (!hasNext && valuesBuiler.contains(",")) {
                                        valuesBuiler.remove(at: valuesBuiler.lastIndex(of: ",")!)
                                    }
                                    continue
                                }
                                
                                let tmp = jsonArray[m].dictionaryValue[key]?.string
                                
                                if (tmp != nil && !(tmp?.isEmpty)! && tmp != "null") {
                                    valuesBuiler.append("'")
                                    valuesBuiler.append(tmp!.replace(target: "'", withString: "''"))
                                    valuesBuiler.append("'")
                                }else if(tmp == "null" || tmp == "NULL"){
                                    valuesBuiler.append("NULL")
                                }else{
                                    
                                    let ddd = nullToNil(value: jsonArray[m].dictionaryValue[key] as AnyObject)
                                    
                                    if let actualVariable = ddd {
                                        valuesBuiler = valuesBuiler + " \(actualVariable)"
                                    }
                                }
                                valuesBuiler.append(hasNext ? "," : "")
                                valuesBuiler = valuesBuiler.trim()
                                if(valuesBuiler.contains(",,") || valuesBuiler.contains(", ,") || valuesBuiler.contains("( ,") || valuesBuiler.contains("(,")){
                                    if(valuesBuiler.contains(",,")){
                                        let newString = valuesBuiler.replacingOccurrences(of: ",,", with: ",'',", options: .literal, range: nil)
                                        valuesBuiler = newString
                                    }
                                    if(valuesBuiler.contains(", ,")){
                                        let newString1 = valuesBuiler.replacingOccurrences(of: ", ,", with: ",'',", options: .literal, range: nil)
                                        valuesBuiler = newString1
                                    }
                                    
                                    if(valuesBuiler.contains("(,")){
                                        let newString3 = valuesBuiler.replacingOccurrences(of: "(,", with: "('',", options: .literal, range: nil)
                                        valuesBuiler = newString3
                                    }
                                    
                                    if(valuesBuiler.contains("( ,")){
                                        let newString3 = valuesBuiler.replacingOccurrences(of: "( ,", with: "('',", options: .literal, range: nil)
                                        valuesBuiler = newString3
                                    }
                                }
                            }
                            valuesBuiler.append(")")
                            
                            if(valuesBuiler.contains(", )")){
                                let newString2 = valuesBuiler.replacingOccurrences(of: ", )", with: ",'')", options: .literal, range: nil)
                                valuesBuiler = newString2
                            }
                            
                            if(valuesBuiler.contains(",)")){
                                let newString3 = valuesBuiler.replacingOccurrences(of: ",)", with: ",'')", options: .literal, range: nil)
                                valuesBuiler = newString3
                            }
                        }
                        finalInsert.append(valuesBuiler)
                        //print("##INSERTED##   \(finalInsert)")
                        
                        if(isTranTable){
                            let deleteQuery = "DELETE FROM \(tableName) WHERE varSync_Code IN (\(deleteQ))"
                            self.database.executeUpdate(deleteQuery, withArgumentsIn: deleteValues)
                            //print("##DELETED##\(deleteCount)")
                        }
                        
                        try self.database.executeUpdate(finalInsert, withArgumentsIn: [])
                        print("##INSERTED##   \(finalInsert)")
                    }
                }
            }
        } catch let error as NSError {
            print("##insertRecordDynamic##   \(error.debugDescription)")
            NSLog("insertRecordDynamic \(error.debugDescription)")
            self.self.syncJSON.setValue("---insertRecordDynamic failed---\(error.debugDescription)", forKey: "34")
            success=false
        }
        //}
        
        return success
    }
    
    func insertRecordDynamicForLAB(tableName:String, jsonArray:JSON)->Bool{
        
        // DispatchQueue.global(qos: .background).async {
        var success = true
        
        do{
            let isTranTable = (tableName == DBHelper.TABLE_LAB_CUSTOMER_DISPATCH
                || tableName == DBHelper.TABLE_LAB_CUSTOMER_DISPATCH_PRODUCT_DETAILS
                || tableName == DBHelper.TABLE_LAB_STORE
                || tableName == DBHelper.TABLE_LAB_DISPOSAL
                || tableName == DBHelper.TABLE_LAB_MATERIAL_ALLOCATION
                || tableName == DBHelper.TABLE_LAB_MATERIAL_RETURN
                || tableName == DBHelper.TABLE_PERSON_MST
                || tableName == DBHelper.TABLE_PRODUCT_SKU_MST
                || tableName == DBHelper.TABLE_CUSTOMER_TYPE_COUNTRY_MST
                || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_LEVEL_COUNTRY_MST
                || tableName == DBHelper.TABLE_POLITICAL_GEOGRAPHY_DETAILS
                || tableName == DBHelper.TABLE_LAB_STICKER_DETAILS)
            print(tableName)
            
            /*if(tableName == "CPM_Sticker_Details" || tableName == "Customer_Type_Country_Mst"){
             let deleteQuery = "DELETE FROM \(tableName)"
             self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
             }*/
            
            /*if(tableName != "CPM_Sticker_Details"){
             return true
             }*/
            
            if !isTranTable && self.database.open()
            {
                let deleteQuery = "DELETE FROM \(tableName)"
                self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                //// print("here one")
            }else{
                if (tableName != DBHelper.TABLE_LAB_CUSTOMER_DISPATCH_PRODUCT_DETAILS) {
                    
                    let deleteQuery = "DELETE FROM \(tableName) WHERE chrSync = 'N'"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                }
                // print("here two")
            }
            
            //            if(tableName == "LAB_Sticker_Details"){
            //                return parseJsonStickerDetailsForLAB(Tourplan_Daily: jsonArray)
            //            }else{
            
            if(jsonArray.count>0){
                
                var sbQuery = ""
                
                sbQuery = "INSERT INTO \(tableName) ("
                
                let keys = jsonArray[0].dictionaryValue.keys
                
                var sbQuery2 = ""
                for (position, name) in keys.enumerated() {
                    if(name=="chrTran"){
                        continue
                    }
                    sbQuery2.append(name)
                    sbQuery2.append(",")
                }
                
                sbQuery2 = sbQuery2.trim()
                sbQuery2 = String(sbQuery2.dropLast())
                
                sbQuery.append(sbQuery2)
                sbQuery.append(" ) VALUES ")
                
                let arraySize = jsonArray.count
                let BATCHSIZE = 150
                let intBatch = Int(CGFloat(ceil(Double(Double(arraySize) * 1.00 / Double(BATCHSIZE)))))-1
                let intRemainder = Int(Double(arraySize).truncatingRemainder(dividingBy: Double(BATCHSIZE)))
                var intMaxRecords = Int(BATCHSIZE)
                
                //print("intBatch:\(intBatch)")
                //print("intRemainder:\(intRemainder)")
                //print("intMaxRecords:\(intMaxRecords)")
                
                //print("here 1:\(sbQuery)")
                
                for b in 0...intBatch {
                    var finalInsert=""
                    finalInsert.append(sbQuery)
                    if (b == intBatch) {
                        intMaxRecords = intRemainder == 0 ? BATCHSIZE : intRemainder;
                    }
                    
                    var valuesBuiler=""
                    var deleteValues = [String]()
                    var deleteQ=""
                    let innerLoopSize = Int((b * Int(BATCHSIZE)) + intMaxRecords)-1
                    let tmp1 = Int((b * BATCHSIZE))
                    
                    //print("BATCHSIZE:\(BATCHSIZE)")
                    //print("innerLoopSize:\(innerLoopSize)")
                    //print("tmp1:\(tmp1)")
                    
                    for m in tmp1...innerLoopSize {
                        //let jsonObject = jsonArray[m]
                        if(jsonArray[m].dictionaryValue.keys.contains("chrTran")){
                            let chrTran = jsonArray[m].dictionaryValue["chrTran"]?.string
                            
                            if (jsonArray[m].dictionaryValue.keys.contains("varSync_Code")) {
                                deleteQ.append(deleteValues.count <= 0 ? "?" : ",?")
                                deleteValues.append((jsonArray[m].dictionaryValue["varSync_Code"]?.string)!)
                            }
                            if (chrTran != nil && chrTran!.caseInsensitiveCompare("d") == .orderedSame) {
                                continue
                            }
                        }
                        
                        if (!valuesBuiler.isEmpty){
                            valuesBuiler.append(",")
                        }
                        
                        valuesBuiler.append("(")
                        
                        for (pos, key) in jsonArray[m].dictionaryValue.keys.enumerated() {
                            let hasNext = (pos != jsonArray[m].dictionaryValue.keys.count-1)
                            if (key=="chrTran") {
                                if (!hasNext && valuesBuiler.contains(",")) {
                                    valuesBuiler.remove(at: valuesBuiler.lastIndex(of: ",")!)
                                }
                                continue
                            }
                            
                            let tmp = jsonArray[m].dictionaryValue[key]?.string
                            
                            if (tmp != nil && !(tmp?.isEmpty)! && tmp != "null") {
                                valuesBuiler.append("'")
                                valuesBuiler.append(tmp!.replace(target: "'", withString: "''"))
                                valuesBuiler.append("'")
                            }else if(tmp == "null" || tmp == "NULL"){
                                valuesBuiler.append("NULL")
                            }else{
                                
                                let ddd = nullToNil(value: jsonArray[m].dictionaryValue[key] as AnyObject)
                                
                                if let actualVariable = ddd {
                                    valuesBuiler = valuesBuiler + " \(actualVariable)"
                                }
                            }
                            valuesBuiler.append(hasNext ? "," : "")
                            valuesBuiler = valuesBuiler.trim()
                            if(valuesBuiler.contains(",,") || valuesBuiler.contains(", ,") || valuesBuiler.contains("( ,") || valuesBuiler.contains("(,")){
                                if(valuesBuiler.contains(",,")){
                                    let newString = valuesBuiler.replacingOccurrences(of: ",,", with: ",'',", options: .literal, range: nil)
                                    valuesBuiler = newString
                                }
                                if(valuesBuiler.contains(", ,")){
                                    let newString1 = valuesBuiler.replacingOccurrences(of: ", ,", with: ",'',", options: .literal, range: nil)
                                    valuesBuiler = newString1
                                }
                                
                                if(valuesBuiler.contains("(,")){
                                    let newString3 = valuesBuiler.replacingOccurrences(of: "(,", with: "('',", options: .literal, range: nil)
                                    valuesBuiler = newString3
                                }
                                
                                if(valuesBuiler.contains("( ,")){
                                    let newString3 = valuesBuiler.replacingOccurrences(of: "( ,", with: "('',", options: .literal, range: nil)
                                    valuesBuiler = newString3
                                }
                            }
                        }
                        valuesBuiler.append(")")
                        
                        if(valuesBuiler.contains(", )")){
                            let newString2 = valuesBuiler.replacingOccurrences(of: ", )", with: ",'')", options: .literal, range: nil)
                            valuesBuiler = newString2
                        }
                        
                        if(valuesBuiler.contains(",)")){
                            let newString3 = valuesBuiler.replacingOccurrences(of: ",)", with: ",'')", options: .literal, range: nil)
                            valuesBuiler = newString3
                        }
                    }
                    finalInsert.append(valuesBuiler)
                    //print("##INSERTED##   \(finalInsert)")
                    
                    if(isTranTable){
                        let deleteQuery = "DELETE FROM \(tableName) WHERE varSync_Code IN (\(deleteQ))"
                        self.database.executeUpdate(deleteQuery, withArgumentsIn: deleteValues)
                        //print("##DELETED##\(deleteCount)")
                    }
                    
                    try self.database.executeUpdate(finalInsert, withArgumentsIn: [])
                    print("##INSERTED##   \(finalInsert)")
                }
                //                }
            }
        } catch let error as NSError {
            print("##insertRecordDynamic##   \(error.debugDescription)")
            NSLog("insertRecordDynamic \(error.debugDescription)")
            success=false
        }
        //}
        
        return success
    }
    
    /*{
     "intGlCode": 17297,
     "fk_StickerGlCode": 10431,
     "varRef_Id": "mA100520191",
     "varSystem_Name": "VCSDES0164",
     "fk_CustomerGlCode": 486,
     "fk_CountryGlCode": 101,
     "fk_PBGGlCode": 18,
     "fk_PRDGlCode": 10,
     "fk_Product_SKUGlCode": 18,
     "varStickerType": "Manual",
     "varDINo": "",
     "varBatch_No": "9",
     "dtMFGDate": null,
     "dtExpireDate": "2019-05-18 00:00:00",
     "intPrintQty": 200,
     "varSticker_From_Range": "mA0519159",
     "varSticker_To_Range": "mA0519358",
     "varBTC_No_In": "mAI19051000127",
     "varBTC_No_Out": "mAO19051000127",
     "varQR_Code_In": "\u001d111905101719051801109\u001d21mAI19051000127",
     "varQR_Code_Out": "\u001d111905101719051801109\u001d21mAO19051000127",
     "varSticker_No": "mA0519285",
     "fk_StatusGlCode": 1,
     "fk_Sticker_GeneratedBy": 486,
     "dtSticker_GeneratedDate": "2019-05-10 07:55:45",
     "chrExternal_Customer": null,
     "fk_Last_DispatchedBy": 0,
     "fk_Last_PreviousDispatchBy": 0,
     "fk_Last_DispatchedTo": 0,
     "dtLast_DispatchedDate": null,
     "fk_Last_ReceivedBy": 0,
     "dtLast_ReceivedDate": null,
     "fk_Last_RejectedBy": "0         ",
     "dtLast_RejectedDate": null,
     "chrDamage": null,
     "dtDamageDateTime": null,
     "fk_DamageBy": 0,
     "chrActive": "Y",
     "chrSync": "Y",
     "varSync_Code": "BF1B63CD-53DB-45B9-9DBE-59C438FB5800",
     "dtSyncDate": "2019-05-10 07:55:45",
     "dtEntryDate": "2019-05-10 07:55:45",
     "ref_Entry_By": 486,
     "dtModifiedDate": null,
     "ref_Modified_By": 0,
     "varLastStage": "PRINTED",
     "chrTran": "I"
     }*/
    
    func parseJsonStickerDetails(Tourplan_Daily:JSON)->Bool{
        //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
        if(Tourplan_Daily.count > 0){
            
            do{
                var k = 0
                while (k < Tourplan_Daily.count){
                    let chrTran = Tourplan_Daily[k]["chrTran"].stringValue
                    
                    if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                        continue
                    }
                    
                    let intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                    let fk_StickerGlCode = Tourplan_Daily[k]["fk_StickerGlCode"].intValue
                    let varRef_Id = Tourplan_Daily[k]["varRef_Id"].stringValue
                    let varSystem_Name = Tourplan_Daily[k]["varSystem_Name"].stringValue
                    let fk_CustomerGlCode = Tourplan_Daily[k]["fk_CustomerGlCode"].intValue
                    let fk_CountryGlCode = Tourplan_Daily[k]["fk_CountryGlCode"].intValue
                    let fk_PBGGlCode = Tourplan_Daily[k]["fk_PBGGlCode"].intValue
                    let fk_PRDGlCode = Tourplan_Daily[k]["fk_PRDGlCode"].intValue
                    var fk_Product_SKUGlCode : Int = 0
                    
                    
                    if Tourplan_Daily[k]["fk_Product_SKUGlCode"] == nil {
                        fk_Product_SKUGlCode = 0
                    }else{
                        fk_Product_SKUGlCode = Tourplan_Daily[k]["fk_Product_SKUGlCode"].intValue
                    }
                    
                    
                    let varStickerType = Tourplan_Daily[k]["varStickerType"].stringValue
                    let varDINo = Tourplan_Daily[k]["varDINo"].stringValue
                    let varBatch_No = Tourplan_Daily[k]["varBatch_No"].stringValue
                    
                    var dtMFGDate:String = ""
                    if Tourplan_Daily[k]["dtMFGDate"] == nil {
                        dtMFGDate = ""
                    }else{
                        dtMFGDate = Tourplan_Daily[k]["dtMFGDate"].stringValue
                    }
                    
                    let dtExpireDate = Tourplan_Daily[k]["dtExpireDate"].stringValue
                    let varSticker_From_Range = Tourplan_Daily[k]["varSticker_From_Range"].stringValue
                    let varSticker_To_Range = Tourplan_Daily[k]["varSticker_To_Range"].stringValue
                    let varBTC_No_In = Tourplan_Daily[k]["varBTC_No_In"].stringValue
                    let varBTC_No_Out = Tourplan_Daily[k]["varBTC_No_Out"].stringValue
                    let varQR_Code_In = Tourplan_Daily[k]["varQR_Code_In"].stringValue
                    let varQR_Code_Out = Tourplan_Daily[k]["varQR_Code_Out"].stringValue
                    
                    let varSticker_No = Tourplan_Daily[k]["varSticker_No"].stringValue
                    
                    var chrPallet:String = ""
                    if Tourplan_Daily[k]["chrPallet"] == nil {
                        chrPallet = ""
                    }else{
                        chrPallet = Tourplan_Daily[k]["chrPallet"].stringValue
                    }
                    
                    var fk_PalletGlCode:Int = 0
                    if Tourplan_Daily[k]["fk_PalletGlCode"] == nil {
                        fk_PalletGlCode = 0
                    }else{
                        fk_PalletGlCode = Tourplan_Daily[k]["fk_PalletGlCode"].intValue
                    }
                    
                    /* let chrPallet = Tourplan_Daily[k]["chrPallet"].stringValue*/
                    /*let fk_PalletGlCode = Tourplan_Daily[k]["fk_PalletGlCode"].intValue*/
                    
                    let fk_StatusGlCode = Tourplan_Daily[k]["fk_StatusGlCode"].intValue
                    let fk_Sticker_GeneratedBy = Tourplan_Daily[k]["fk_Sticker_GeneratedBy"].intValue
                    let dtSticker_GeneratedDate = Tourplan_Daily[k]["dtSticker_GeneratedDate"].stringValue
                    
                    var chrExternal_Customer:String = ""
                    if Tourplan_Daily[k]["chrExternal_Customer"] == nil {
                        chrExternal_Customer = ""
                    }else{
                        chrExternal_Customer = Tourplan_Daily[k]["chrExternal_Customer"].stringValue
                    }
                    
                    let fk_Last_DispatchedBy = Tourplan_Daily[k]["fk_Last_DispatchedBy"].intValue
                    let fk_Last_PreviousDispatchBy = Tourplan_Daily[k]["fk_Last_PreviousDispatchBy"].intValue
                    let fk_Last_DispatchedTo = Tourplan_Daily[k]["fk_Last_DispatchedTo"].intValue
                    
                    let dtLast_DispatchedDate = Tourplan_Daily[k]["dtLast_DispatchedDate"].stringValue
                    let fk_Last_ReceivedBy = Tourplan_Daily[k]["fk_Last_ReceivedBy"].intValue
                    
                    var dtLast_RejectedDate:String = ""
                    if Tourplan_Daily[k]["dtLast_RejectedDate"] == nil {
                        dtLast_RejectedDate = ""
                    }else{
                        dtLast_RejectedDate = Tourplan_Daily[k]["dtLast_RejectedDate"].stringValue
                    }
                    
                    var chrDamage:String = ""
                    if Tourplan_Daily[k]["chrDamage"] == nil {
                        chrDamage = ""
                    }else{
                        chrDamage = Tourplan_Daily[k]["chrDamage"].stringValue
                    }
                    
                    var dtDamageDateTime:String = ""
                    if Tourplan_Daily[k]["dtDamageDateTime"] == nil {
                        dtDamageDateTime = ""
                    }else{
                        dtDamageDateTime = Tourplan_Daily[k]["dtDamageDateTime"].stringValue
                    }
                    
                    let fk_DamageBy = Tourplan_Daily[k]["fk_DamageBy"].intValue
                    
                    var chrActive:String = ""
                    if Tourplan_Daily[k]["chrActive"] == nil {
                        chrActive = ""
                    }else{
                        chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                    }
                    
                    var chrSync:String = ""
                    if Tourplan_Daily[k]["chrSync"] == nil {
                        chrSync = ""
                    }else{
                        chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                    }
                    
                    var varSync_Code:String = ""
                    if Tourplan_Daily[k]["varSync_Code"] == nil {
                        varSync_Code = ""
                    }else{
                        varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                    }
                    
                    var dtSyncDate:String = ""
                    if Tourplan_Daily[k]["dtSyncDate"] == nil {
                        dtSyncDate = ""
                    }else{
                        dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                    }
                    
                    var dtEntryDate:String = ""
                    if Tourplan_Daily[k]["dtEntryDate"] == nil {
                        dtEntryDate = ""
                    }else{
                        dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                    }
                    
                    var ref_Entry_By:Int = 0
                    if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                        ref_Entry_By = 0
                    }else{
                        ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].intValue
                    }
                    
                    
                    var intPrintQty:Int = 0
                    if Tourplan_Daily[k]["intPrintQty"] == nil {
                        intPrintQty = 0
                    }else{
                        intPrintQty = Tourplan_Daily[k]["intPrintQty"].intValue
                    }
                    
                    var dtModifiedDate:String = ""
                    if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                        dtModifiedDate = ""
                    }else{
                        dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                    }
                    
                    var ref_Modified_By:Int = 0
                    if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                        ref_Modified_By = 0
                    }else{
                        ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                    }
                    
                    var fk_Last_RejectedBy:Int = 0
                    if Tourplan_Daily[k]["fk_Last_RejectedBy"] == nil {
                        ref_Modified_By = 0
                    }else{
                        fk_Last_RejectedBy = Tourplan_Daily[k]["fk_Last_RejectedBy"].intValue
                    }
                    
                    
                    
                    var varLastStage:String = ""
                    if Tourplan_Daily[k]["varLastStage"] == nil {
                        varLastStage = ""
                    }else{
                        varLastStage = Tourplan_Daily[k]["varLastStage"].stringValue
                    }
                    
                    var dtLast_ReceivedDate:String = ""
                    if Tourplan_Daily[k]["dtLast_ReceivedDate"] == nil {
                        dtLast_ReceivedDate = ""
                    }else{
                        dtLast_ReceivedDate = Tourplan_Daily[k]["dtLast_ReceivedDate"].stringValue
                    }
                    
                    var chrConsume:String = ""
                    if Tourplan_Daily[k]["chrConsume"] == nil {
                        chrConsume = ""
                    }else{
                        chrConsume = Tourplan_Daily[k]["chrConsume"].stringValue
                    }
                    
                    var dtConsumeDateTime:String = ""
                    if Tourplan_Daily[k]["dtConsumeDateTime"] == nil {
                        dtConsumeDateTime = ""
                    }else{
                        dtConsumeDateTime = Tourplan_Daily[k]["dtConsumeDateTime"].stringValue
                    }
                    
                    var fk_ConsumeBy:Int = 0
                    if Tourplan_Daily[k]["fk_ConsumeBy"] == nil {
                        fk_ConsumeBy = 0
                    }else{
                        fk_ConsumeBy = Tourplan_Daily[k]["fk_ConsumeBy"].intValue
                    }
                    
                    var chrScrap:String = ""
                    if Tourplan_Daily[k]["chrScrap"] == nil {
                        chrScrap = ""
                    }else{
                        chrScrap = Tourplan_Daily[k]["chrScrap"].stringValue
                    }
                    
                    var dtScrapDateTime:String = ""
                    if Tourplan_Daily[k]["dtScrapDateTime"] == nil {
                        dtScrapDateTime = ""
                    }else{
                        dtScrapDateTime = Tourplan_Daily[k]["dtScrapDateTime"].stringValue
                    }
                    
                    var fk_ScrapBy:Int = 0
                    if Tourplan_Daily[k]["fk_ScrapBy"] == nil {
                        fk_ScrapBy = 0
                    }else{
                        fk_ScrapBy = Tourplan_Daily[k]["fk_ScrapBy"].intValue
                    }
                    
                    /*var dtLast_ReceivedDate:String = ""
                     if Tourplan_Daily[k]["dtLast_ReceivedDate"] == nil {
                     dtLast_ReceivedDate = ""
                     }else{
                     dtLast_ReceivedDate = Tourplan_Daily[k]["dtLast_ReceivedDate"].stringValue
                     }*/
                    
                    //print("fk_CampGlCode JJ \(fk_CampGlCode)")
                    
                    /*if(checkTourplan_DailyCount(fk_DrGlCode: fk_DrGlCode, fk_EmpGlCode_Planned: fk_EmpGlCode_Planned, fk_DivisionGlCode: fk_DivisionGlCode, dtPlanDate: dtPlanDate) > 0){
                     
                     let update = "update Tourplan_Daily set fk_PurposeGlCode = ?,fk_DrGlCode = ?, fk_EmpGlCode_Planned = ?, dtEntryDate = ?, fk_DivisionGlCode = ?, fk_PersonGlCode = ?, chrDeleteFlag = ?, dtPlanDate = ?, fk_CampGlCode = ?, varTime = ?,  fk_DesiGlCode = ?, chrSyncFlag = ? where fk_DrGlCode = \(fk_DrGlCode) and fk_EmpGlCode_Planned = \(fk_EmpGlCode_Planned) and dtPlanDate = '\(dtPlanDate)' "
                     
                     try database.executeUpdate(update, values: [fk_PurposeGlCode, fk_DrGlCode,fk_EmpGlCode_Planned,dtEntryDate,fk_DivisionGlCode,fk_PersonGlCode,chrDeleteFlag,dtPlanDate,fk_CampGlCode,varTime,fk_DesiGlCode,chrSyncFlag])
                     
                     }else{*/
                    
                    
                    let deleteQuery = "DELETE FROM CPM_Sticker_Details WHERE varSync_Code IN ('\(varSync_Code)')"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    print("delete from sticker details----\(fk_StickerGlCode)-------\(varSync_Code)")
                    
                    try self.database.executeUpdate("insert into CPM_Sticker_Details (intGlCode, fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,chrPallet,fk_PalletGlCode,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage,chrConsume,dtConsumeDateTime,fk_ConsumeBy,chrScrap,dtScrapDateTime,fk_ScrapBy) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [intGlCode,fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,chrPallet,fk_PalletGlCode,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage,chrConsume,dtConsumeDateTime,fk_ConsumeBy,chrScrap,dtScrapDateTime,fk_ScrapBy])
                    //}
                    
                    k += 1
                }
            }catch{
                print("error Tourplan_Daily")
                
                return false
            }
            
            return true
        }
        
        return false
        //}
    }
    
    func parseJsonStickerDetailsForLAB(Tourplan_Daily:JSON)->Bool{
        //if let Tourplan_Daily = Tourplan_Daily1["Tourplan_Daily"].array {
        if(Tourplan_Daily.count > 0){
            
            do{
                var k = 0
                while (k < Tourplan_Daily.count){
                    let chrTran = Tourplan_Daily[k]["chrTran"].stringValue
                    
                    if(chrTran != nil && chrTran.caseInsensitiveCompare("d") == .orderedSame){
                        continue
                    }
                    
                    let intGlCode = Tourplan_Daily[k]["intGlCode"].intValue
                    let fk_StickerGlCode = Tourplan_Daily[k]["fk_StickerGlCode"].intValue
                    let varRef_Id = Tourplan_Daily[k]["varRef_Id"].stringValue
                    let varRef_Id_Counter = Tourplan_Daily[k]["varRef_Id_Counter"].stringValue
                    let varSystem_Name = Tourplan_Daily[k]["varSystem_Name"].stringValue
                    let fk_CustomerGlCode = Tourplan_Daily[k]["fk_CustomerGlCode"].intValue
                    let fk_CountryGlCode = Tourplan_Daily[k]["fk_CountryGlCode"].intValue
                    let fk_PBGGlCode = Tourplan_Daily[k]["fk_PBGGlCode"].intValue
                    let fk_PRDGlCode = Tourplan_Daily[k]["fk_PRDGlCode"].intValue
                    var fk_Product_SKUGlCode : Int = 0
                    
                    
                    if Tourplan_Daily[k]["fk_Product_SKUGlCode"] == nil {
                        fk_Product_SKUGlCode = 0
                    }else{
                        fk_Product_SKUGlCode = Tourplan_Daily[k]["fk_Product_SKUGlCode"].intValue
                    }
                    
                    
                    let varStickerType = Tourplan_Daily[k]["varStickerType"].stringValue
                    let varDINo = Tourplan_Daily[k]["varDINo"].stringValue
                    let varBatch_No = Tourplan_Daily[k]["varBatch_No"].stringValue
                    
                    var dtMFGDate:String = ""
                    if Tourplan_Daily[k]["dtMFGDate"] == nil {
                        dtMFGDate = ""
                    }else{
                        dtMFGDate = Tourplan_Daily[k]["dtMFGDate"].stringValue
                    }
                    
                    let dtExpireDate = Tourplan_Daily[k]["dtExpireDate"].stringValue
                    let varSticker_From_Range = Tourplan_Daily[k]["varSticker_From_Range"].stringValue
                    let varSticker_To_Range = Tourplan_Daily[k]["varSticker_To_Range"].stringValue
                    let varBTC_No_In = Tourplan_Daily[k]["varBTC_No_In"].stringValue
                    let varBTC_No_Out = Tourplan_Daily[k]["varBTC_No_Out"].stringValue
                    let varQR_Code_In = Tourplan_Daily[k]["varQR_Code_In"].stringValue
                    let varQR_Code_Out = Tourplan_Daily[k]["varQR_Code_Out"].stringValue
                    
                    let varSticker_No = Tourplan_Daily[k]["varSticker_No"].stringValue
                    
                    var chrPallet:String = ""
                    if Tourplan_Daily[k]["chrPallet"] == nil {
                        chrPallet = ""
                    }else{
                        chrPallet = Tourplan_Daily[k]["chrPallet"].stringValue
                    }
                    
                    var fk_PalletGlCode:Int = 0
                    if Tourplan_Daily[k]["fk_PalletGlCode"] == nil {
                        fk_PalletGlCode = 0
                    }else{
                        fk_PalletGlCode = Tourplan_Daily[k]["fk_PalletGlCode"].intValue
                    }
                    
                    /* let chrPallet = Tourplan_Daily[k]["chrPallet"].stringValue*/
                    /*let fk_PalletGlCode = Tourplan_Daily[k]["fk_PalletGlCode"].intValue*/
                    
                    let fk_StatusGlCode = Tourplan_Daily[k]["fk_StatusGlCode"].intValue
                    let fk_Sticker_GeneratedBy = Tourplan_Daily[k]["fk_Sticker_GeneratedBy"].intValue
                    let dtSticker_GeneratedDate = Tourplan_Daily[k]["dtSticker_GeneratedDate"].stringValue
                    
                    var chrExternal_Customer:String = ""
                    if Tourplan_Daily[k]["chrExternal_Customer"] == nil {
                        chrExternal_Customer = ""
                    }else{
                        chrExternal_Customer = Tourplan_Daily[k]["chrExternal_Customer"].stringValue
                    }
                    
                    let fk_Last_DispatchedBy = Tourplan_Daily[k]["fk_Last_DispatchedBy"].intValue
                    let fk_Last_PreviousDispatchBy = Tourplan_Daily[k]["fk_Last_PreviousDispatchBy"].intValue
                    let fk_Last_DispatchedTo = Tourplan_Daily[k]["fk_Last_DispatchedTo"].intValue
                    
                    let dtLast_DispatchedDate = Tourplan_Daily[k]["dtLast_DispatchedDate"].stringValue
                    let fk_Last_ReceivedBy = Tourplan_Daily[k]["fk_Last_ReceivedBy"].intValue
                    
                    var dtLast_RejectedDate:String = ""
                    if Tourplan_Daily[k]["dtLast_RejectedDate"] == nil {
                        dtLast_RejectedDate = ""
                    }else{
                        dtLast_RejectedDate = Tourplan_Daily[k]["dtLast_RejectedDate"].stringValue
                    }
                    
                    var chrDamage:String = ""
                    if Tourplan_Daily[k]["chrDamage"] == nil {
                        chrDamage = ""
                    }else{
                        chrDamage = Tourplan_Daily[k]["chrDamage"].stringValue
                    }
                    
                    var dtDamageDateTime:String = ""
                    if Tourplan_Daily[k]["dtDamageDateTime"] == nil {
                        dtDamageDateTime = ""
                    }else{
                        dtDamageDateTime = Tourplan_Daily[k]["dtDamageDateTime"].stringValue
                    }
                    
                    let fk_DamageBy = Tourplan_Daily[k]["fk_DamageBy"].intValue
                    
                    var chrActive:String = ""
                    if Tourplan_Daily[k]["chrActive"] == nil {
                        chrActive = ""
                    }else{
                        chrActive = Tourplan_Daily[k]["chrActive"].stringValue
                    }
                    
                    var chrSync:String = ""
                    if Tourplan_Daily[k]["chrSync"] == nil {
                        chrSync = ""
                    }else{
                        chrSync = Tourplan_Daily[k]["chrSync"].stringValue
                    }
                    
                    var varSync_Code:String = ""
                    if Tourplan_Daily[k]["varSync_Code"] == nil {
                        varSync_Code = ""
                    }else{
                        varSync_Code = Tourplan_Daily[k]["varSync_Code"].stringValue
                    }
                    
                    var dtSyncDate:String = ""
                    if Tourplan_Daily[k]["dtSyncDate"] == nil {
                        dtSyncDate = ""
                    }else{
                        dtSyncDate = Tourplan_Daily[k]["dtSyncDate"].stringValue
                    }
                    
                    var dtEntryDate:String = ""
                    if Tourplan_Daily[k]["dtEntryDate"] == nil {
                        dtEntryDate = ""
                    }else{
                        dtEntryDate = Tourplan_Daily[k]["dtEntryDate"].stringValue
                    }
                    
                    var ref_Entry_By:Int = 0
                    if Tourplan_Daily[k]["ref_Entry_By"] == nil {
                        ref_Entry_By = 0
                    }else{
                        ref_Entry_By = Tourplan_Daily[k]["ref_Entry_By"].intValue
                    }
                    
                    
                    var intPrintQty:Int = 0
                    if Tourplan_Daily[k]["intPrintQty"] == nil {
                        intPrintQty = 0
                    }else{
                        intPrintQty = Tourplan_Daily[k]["intPrintQty"].intValue
                    }
                    
                    var dtModifiedDate:String = ""
                    if Tourplan_Daily[k]["dtModifiedDate"] == nil {
                        dtModifiedDate = ""
                    }else{
                        dtModifiedDate = Tourplan_Daily[k]["dtModifiedDate"].stringValue
                    }
                    
                    var ref_Modified_By:Int = 0
                    if Tourplan_Daily[k]["ref_Modified_By"] == nil {
                        ref_Modified_By = 0
                    }else{
                        ref_Modified_By = Tourplan_Daily[k]["ref_Modified_By"].intValue
                    }
                    
                    var fk_Last_RejectedBy:Int = 0
                    if Tourplan_Daily[k]["fk_Last_RejectedBy"] == nil {
                        ref_Modified_By = 0
                    }else{
                        fk_Last_RejectedBy = Tourplan_Daily[k]["fk_Last_RejectedBy"].intValue
                    }
                    
                    
                    
                    var varLastStage:String = ""
                    if Tourplan_Daily[k]["varLastStage"] == nil {
                        varLastStage = ""
                    }else{
                        varLastStage = Tourplan_Daily[k]["varLastStage"].stringValue
                    }
                    
                    var dtLast_ReceivedDate:String = ""
                    if Tourplan_Daily[k]["dtLast_ReceivedDate"] == nil {
                        dtLast_ReceivedDate = ""
                    }else{
                        dtLast_ReceivedDate = Tourplan_Daily[k]["dtLast_ReceivedDate"].stringValue
                    }
                    
                    /*var dtLast_ReceivedDate:String = ""
                     if Tourplan_Daily[k]["dtLast_ReceivedDate"] == nil {
                     dtLast_ReceivedDate = ""
                     }else{
                     dtLast_ReceivedDate = Tourplan_Daily[k]["dtLast_ReceivedDate"].stringValue
                     }*/
                    
                    //print("fk_CampGlCode JJ \(fk_CampGlCode)")
                    
                    /*if(checkTourplan_DailyCount(fk_DrGlCode: fk_DrGlCode, fk_EmpGlCode_Planned: fk_EmpGlCode_Planned, fk_DivisionGlCode: fk_DivisionGlCode, dtPlanDate: dtPlanDate) > 0){
                     
                     let update = "update Tourplan_Daily set fk_PurposeGlCode = ?,fk_DrGlCode = ?, fk_EmpGlCode_Planned = ?, dtEntryDate = ?, fk_DivisionGlCode = ?, fk_PersonGlCode = ?, chrDeleteFlag = ?, dtPlanDate = ?, fk_CampGlCode = ?, varTime = ?,  fk_DesiGlCode = ?, chrSyncFlag = ? where fk_DrGlCode = \(fk_DrGlCode) and fk_EmpGlCode_Planned = \(fk_EmpGlCode_Planned) and dtPlanDate = '\(dtPlanDate)' "
                     
                     try database.executeUpdate(update, values: [fk_PurposeGlCode, fk_DrGlCode,fk_EmpGlCode_Planned,dtEntryDate,fk_DivisionGlCode,fk_PersonGlCode,chrDeleteFlag,dtPlanDate,fk_CampGlCode,varTime,fk_DesiGlCode,chrSyncFlag])
                     
                     }else{*/
                    
                    //46
                    //30
                    
                    let deleteQuery = "DELETE FROM CPM_Sticker_Details WHERE varSync_Code IN ('\(varSync_Code)')"
                    self.database.executeUpdate(deleteQuery, withArgumentsIn: [])
                    print("delete from sticker details----\(fk_StickerGlCode)-------\(varSync_Code)")
                    
                    try self.database.executeUpdate("insert into CPM_Sticker_Details (intGlCode, fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,chrPallet,fk_PalletGlCode,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage) values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)", values: [intGlCode,fk_StickerGlCode,varRef_Id,varSystem_Name,fk_CustomerGlCode,fk_CountryGlCode,fk_PBGGlCode,fk_PRDGlCode,fk_Product_SKUGlCode,varStickerType,varDINo,varBatch_No,dtMFGDate,dtExpireDate,intPrintQty,varSticker_From_Range,varSticker_To_Range,varBTC_No_In,varBTC_No_Out,varQR_Code_In,varQR_Code_Out,varSticker_No,chrPallet,fk_PalletGlCode,fk_StatusGlCode,fk_Sticker_GeneratedBy,dtSticker_GeneratedDate,chrExternal_Customer,fk_Last_DispatchedBy,fk_Last_PreviousDispatchBy,fk_Last_DispatchedTo,dtLast_DispatchedDate,fk_Last_ReceivedBy,dtLast_ReceivedDate,fk_Last_RejectedBy,dtLast_RejectedDate,chrDamage,dtDamageDateTime,fk_DamageBy,chrActive,chrSync,varSync_Code,dtSyncDate,dtEntryDate,ref_Entry_By,dtModifiedDate,ref_Modified_By,varLastStage])
                    //}
                    
                    k += 1
                }
            }catch{
                print("error Tourplan_Daily")
                
                return false
            }
            
            return true
        }
        
        return false
        //}
    }
    
    func nullToNil(value : AnyObject?) -> AnyObject? {
        if value is NSNull {
            return nil
        } else {
            return value
        }
    }
    
    func intValueForKey(key: String, inDictionary dictionary: [String: AnyObject]) throws -> Int {
        if let value = dictionary[key]?.integerValue {
            return value
        } else {
            throw NSError(domain: "Invalid key", code: -1, userInfo: nil)
        }
    }
    
    func stringValueForKey(key: String, inDictionary dictionary: [String: AnyObject]) throws -> String {
        if let value = dictionary[key]?.stringValue {
            return value
        } else {
            throw NSError(domain: "Invalid key", code: -1, userInfo: nil)
        }
    }
    
    func unzipFile(zipPath: String, destinationPath:String) -> Bool{
        var fileUnZip = false
        //let s:Bool =  SSZipArchive.unzipFile(atPath: zipPath, toDestination: destinationPath)
        
        var s:Bool = false
        let success = SSZipArchive.isFilePasswordProtected(atPath: zipPath)
        if success {
            print("Yes, it's password protected.")
            //info.text = "Yes, it's password protected."
            
            s   = SSZipArchive.unzipFile(atPath: zipPath,
                                         toDestination: destinationPath,
                                         preserveAttributes: true,
                                         overwrite: true,
                                         nestedZipLevel: 1,
                                         password: ZipPassword,
                                         error: nil,
                                         delegate: nil,
                                         progressHandler: nil,
                                         completionHandler: nil)
        } else {
            print("No, it's not password protected.")
            //info.text = "No, it's not password protected."
            s =  SSZipArchive.unzipFile(atPath: zipPath, toDestination: destinationPath)
        }
        
        if(s){
            fileUnZip = true
            //print("unzip zip file")
        }else{
            fileUnZip = false
            //print("not unzip zip file")
        }
        return fileUnZip
    }
    
    func writeLog(key: String, value: String){
        let todaysDate = getCurrentDateTimeFormated()
        let logData = "\(key) $$$ \(value) $$$ Date Time:- \(todaysDate)"
        ////print(logData)
        hashMap[key] = logData
    }
    
    func updateProgress(type:Int, message:String, min: Int, max: Int){
        
        if(type==1){
            returnItems = ["type": "\(type)","Details": message,"progress": "\(randomNumber(MIN: min, MAX: max))"]
            NotificationCenter.default.post(name: notificationName, object: nil)
        }
        else if(type==2 || type==3){
            var status=""
            if(type==2){
                status="N"
            }else{
                status="Y"
            }
            
            self.SyncDone(type:type,message:message,min:min,max:max)
            
            self.callUpload(urlUpload: urlUpload, logUploadMethod: logUploadMethod, fk_EmpGlCode: fk_EmpGlCode, SyncId: self.SyncId, DeviceSyncStatus: status, DeviceSyncJson: status, ClientName: ClientName, imei: imei, version: version, userName: userName,type: type,message: message,min: min,max: max)
            
            /*if(type==3){
             
             }else{
             returnItems = ["type": "\(type)","Details": message,"progress": "\(randomNumber(MIN: min, MAX: max))"]
             NotificationCenter.default.post(name: notificationName, object: nil)
             }*/
            //sleep(3)
            
            
        }
    }
    
    func deleteTable(database:FMDatabase, tableName:String){
        if database.open()
        {
            let deleteQuery = "DELETE FROM \(tableName) WHERE chrSync = 'N'"
            database.executeUpdate(deleteQuery, withArgumentsIn: [])
        }
    }
    
    func getJsonFromTable(database:FMDatabase,tableName:String)->JSON{
        //var varIntRowCount:String = ""
        if database.open()
        {
            let selectQuery = "SELECT * FROM \(tableName) WHERE chrSync = 'N'"
            //print(selectQuery)
            
            if let rs = database.executeQuery(selectQuery, withArgumentsIn: [])
            {
                var data = [JSON]()
                
                while(rs.next()){
                    let dir = rs.resultDictionary
                    //print(dir)
                    let json = JSON(dir)
                    data.append(json)
                }
                return JSON(data)
            }
        }
        
        return JSON("[]")
    }
    
    func writeTransactionTablesToFile(tableName: String, NumberOfRecordPerArray: Int, intRowNumber: Int, filePath: String) {
        
        var isExit:Bool = false
        var fileCount:Int = 0
        var tmpRowNumber = intRowNumber
        
        //var jsonArray = [JSON]()
        
        repeat {
            let selectQuery = "SELECT * FROM \(tableName) WHERE chrSync = 'N' AND intGlCode > \(tmpRowNumber) LIMIT 2000"
            
            let selectQueryCount = "SELECT COUNT(*) as Count FROM \(tableName) WHERE chrSync = 'N' AND intGlCode > \(tmpRowNumber) LIMIT 2000"
            
            //print(selectQuery)
            
            var count = 0
            if let rs = database.executeQuery(selectQueryCount, withArgumentsIn: []) {
                while rs.next() {
                    count = Int(rs.int(forColumn: "Count"))
                    print("Total Records:", count)
                }
            }
            if(count>0){
                if let rs = database.executeQuery(selectQuery, withArgumentsIn: [])
                {
                    var data = [JSON]()
                    
                    var limitCount=0
                    while(rs.next()){
                        let dir = rs.resultDictionary
                        //print(dir)
                        let json = JSON(dir)
                        //print(json)
                        data.append(json)
                        limitCount+=1
                        
                        isExit = limitCount==count
                        
                        if(data.count >= 1000 || isExit){
                            fileCount+=1;
                            generateTextFile(root: filePath, sFileName: "\(tableName)$_\(fileCount).txt", sBody: "\(data)")
                            //tmpRowNumber = data[data.count-1].arrayValue.last!["intGlCode"].intValue
                            tmpRowNumber = dir!["intGlCode"] as! Int
                            data.removeAll()
                        }
                    }
                }
            }else{
                isExit = true
            }
            
        } while !isExit;
    }
    
    func generateTextFile(root: String, sFileName: String, sBody: String){
        
        //print("Generate File")
        //print(root)
        //print(sFileName)
        
        
        let filePath = root.appending("/" + sFileName)
        
        do {
            try sBody.write(toFile: filePath, atomically: false, encoding: String.Encoding.utf8)
        }
        catch let error as NSError {
            print("An error took place: \(error)")
        }
    }
    
    func callUpload(urlUpload: String, logUploadMethod: String, fk_EmpGlCode: String, SyncId: Int, DeviceSyncStatus: String, DeviceSyncJson: String, ClientName: String, imei: String, version: String, userName: String,type:Int,message:String,min:Int,max:Int){
        let DeviceSyncJson="\(self.hashMap)"
        //print("DeviceSyncJson ### \(DeviceSyncJson)")
        
        self.uploadLogToServerAfterSync(urlUpload: urlUpload, logUploadMethod: logUploadMethod, PersonId: fk_EmpGlCode, SyncId: self.SyncId, DeviceSyncStatus: DeviceSyncStatus, DeviceSyncJson: DeviceSyncJson, SubModuleName: ClientName, DeviceId: imei, Version: version, APIToken: userName,type: type,message: message,min: min,max: max)
    }
    
    func uploadLogToServerAfterSync(urlUpload: String, logUploadMethod: String, PersonId: String, SyncId: Int, DeviceSyncStatus: String, DeviceSyncJson: String, SubModuleName: String, DeviceId: String, Version: String, APIToken: String,type:Int,message:String,min:Int,max:Int){
        //print("uploadLogToServerAfterSync START \(DeviceSyncStatus)")
        let parameters = [
            "PersonId": "\(PersonId)",
            "SyncId": "\(SyncId)",
            "DeviceSyncStatus": "\(DeviceSyncStatus)",
            "DeviceSyncJson": "\(self.syncJSONInString())",
            "SubModuleName": "\(SubModuleName)",
            "DeviceId": "\(DeviceId)",
            "Version": "\(Version)",
            "APIToken": "\(APIToken)",
            
            "SyncType": "\(self.syncType)",
            "SyncLogJson": "{\"Sync_Log\":[\"\(self.requestJSONInString())\"]}",
            "ExtraFields": ""
        ]
        
        print(parameters)
        print(logURL)
        print(logMethod)
        let web = logURL + logMethod
        //logMethod = methodSyncID
        //let web = urlUpload + logUploadMethod
        //let web = "https://basf-dlite3-fulfil.ecubix.com/service/services.asmx/DeviceSyncLog"
        print(web)
        self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
            
            .responseString { response in
                print("logUploadMethod - Success: \(logUploadMethod) \(response.result)")
                
                /* DispatchQueue.main.async {
                 
                 //self.SyncDone(type:type,message:message,min:min,max:max)
                 }*/
        }
        
        //sleep(2)
        
        
    }
    
    func SyncDone(type:Int,message:String,min:Int,max:Int){
        self.returnItems = ["type": "\(type)","Details": message,"progress": "\(self.randomNumber(MIN: min, MAX: max))"]
        NotificationCenter.default.post(name: self.notificationName, object: nil)
    }
    
    func getCurrentDateTimeFormated() -> String{
        let date : Date = Date()
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        return dateFormatter.string(from: date)
    }
    
    //File Sync END
    
    @objc func onBatteryStateDidChange(_ notification: Notification?) {
        //print("onBatteryStateDidChange")
        sendBatteryStateEvent()
    }
    
    func sendBatteryStateEvent() {
        if eventSink == nil {
            //print("eventSink nil")
            return
        }
        
        eventSink?(returnItems)
        
    }
    
    public func onListen(withArguments arguments: Any?, eventSink: @escaping FlutterEventSink) -> FlutterError? {
        self.eventSink = eventSink
        //UIDevice.current.isBatteryMonitoringEnabled = true
        //sendBatteryStateEvent()
        NotificationCenter.default.addObserver(self, selector: #selector(onBatteryStateDidChange(_:)), name: notificationName, object: nil)
        return nil
    }
    
    public func onCancel(withArguments arguments: Any?) -> FlutterError? {
        NotificationCenter.default.removeObserver(self)
        eventSink = nil
        return nil
    }
    
    /*func handle(_ call: FlutterMethodCall?, result: FlutterResult) {
     if ("getBatteryLevel" == call?.method) {
     let batteryLevel: Int = getBatteryLevel()
     if batteryLevel == -1 {
     result(FlutterError(code: "UNAVAILABLE", message: "Battery info unavailable", details: nil))
     } else {
     result(batteryLevel)
     }
     } else {
     result(FlutterMethodNotImplemented)
     }
     }*/
    
    /*func getBatteryLevel() -> Int {
     let device = UIDevice.current
     device.isBatteryMonitoringEnabled = true
     if device.batteryState == .unknown {
     return -1
     } else {
     return Int(device.batteryLevel * 100)
     }
     }*/
    
    func SyncData(userName:String,fk_EmpGlCode:String,ClientName:String,version:String,imei:String,uploadMethod:String,urlUpload:String,databaseName:String, dbPassword:String, isDbEncripted:String)->String{
        
        self.userName=userName;
        self.fk_EmpGlCode=fk_EmpGlCode;
        self.ClientName=ClientName;
        self.version=version;
        self.imei=imei;
        self.uploadMethod=uploadMethod;
        self.logUploadMethod=urlUpload;
        self.urlUpload=urlUpload;
        
        print("*****************")
        print(logUploadMethod)
        print(uploadMethod)
        
        //xx
        requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_START")
        
        //returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 1,MAX: 5))"]
        //NotificationCenter.default.post(name: notificationName, object: nil)
        self.updateProgress(type: 1, message: "progress", min: 1, max: 5)
        
        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""
        
        let date = Date()
        let calendar = Calendar.current
        
        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)
        
        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)
        
        let dirName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        
        let fileName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        let zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_BASF-HK-Database"
        self.zipNameFinal = zipName
        // App database path
        let filePathFrom = documentsPath.appendingPathComponent(databaseName)?.path
        let filePathTo = documentsPath.appendingPathComponent("SyncDatabase")?.path
        //let filePathTo1 = documentsPath.appendingPathComponent("SyncDatabase/\(databaseName)")?.path
        //let filePathTo2 = documentsPath.appendingPathComponent("SyncDatabase/\(fileName)")?.path
        let fileManager = FileManager.default
        
        //createDirSyncDb(documentsPath)
        
        if fileManager.fileExists(atPath: filePathTo!) {
            do {
                try fileManager.removeItem(atPath: filePathTo!)
            } catch let error as NSError {
                NSLog("delete directory \(error.debugDescription)")
                isGoahead = false;
                isGoaheadMessage = "error:101";
            }
            createDirSyncDb(documentsPath: documentsPath)
        } else {
            createDirSyncDb(documentsPath: documentsPath)
        }
        
        if(isGoahead){
            /*if fileManager.fileExists(atPath: filePathTo1!) {
                //print("filePathTo1 exist")
            }
            if fileManager.fileExists(atPath: filePathTo2!) {
                //print("filePathTo2 exist")
            }*/
            //databaseName = "BASF-HK-Database"
            let filePathToZip = documentsPath.appendingPathComponent("SyncDatabase/\(zipName).zip")?.path
            
            let newDirectory = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)")?.path
            
            let newDirectory1 = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)/\(fileName)")?.path
            
            do {
                try fileManager.createDirectory(atPath: newDirectory!, withIntermediateDirectories: false, attributes: nil)
            } catch let error as NSError {
                //print(error.localizedDescription);
                //print("error create newDirectory")
                //print("Ooops! Something went wrong createDirectory: \(error)")
                isGoahead = false;
                isGoaheadMessage = "error:103 \(error)";
            }
            
            requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_START")
            syncJSON.setValue("---Export Database Start---", forKey: "1")
            
            //copy from SyncDatabase to document
            if fileManager.fileExists(atPath: filePathFrom!) {
                do {
                    try fileManager.copyItem(atPath: filePathFrom!, toPath: newDirectory1!)
                    
                    requestJSON.setValue(Date().getJsonLogTime(), forKey: "EXPORT_FILE_END")
                    syncJSON.setValue("---Export Database End---", forKey: "2")
                    
                } catch let error as NSError {
                    NSLog("Unable to copy file \(error.debugDescription)")
                    //print("Ooops! Something went wrong copyItem: \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:103";
                    syncJSON.setValue("---Export database failed---", forKey: "9")
                }
            }
            
            //returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 6,MAX: 10))"]
            //NotificationCenter.default.post(name: notificationName, object: nil)
            self.updateProgress(type: 1, message: "progress", min: 6, max: 10)
            
            if(isGoahead){
                requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_START")
                syncJSON.setValue("---Create Zip File Start---", forKey: "3")
                
                if(isDbEncripted == "true"){
                    let success = SSZipArchive.createZipFile(atPath: filePathToZip!,
                                                             withContentsOfDirectory: newDirectory!,
                                                             keepParentDirectory: false,
                                                             compressionLevel: 5,
                                                             password: ZipPassword,
                                                             aes: true,
                                                             progressHandler: nil)
                    //let success = SSZipArchive.createZipFile(atPath: filePathToZip!, withContentsOfDirectory: newDirectory!)
                    if(success){
                        requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_END")
                        syncJSON.setValue("---Create Zip File End---", forKey: "4")
                        isGoahead = true
                    }else{
                        isGoahead = false
                        isGoaheadMessage = "Error creating zip"
                        syncJSON.setValue("---Failed to create zip file---", forKey: "8")
                    }
                }else{
                    let success = SSZipArchive.createZipFile(atPath: filePathToZip!, withContentsOfDirectory: newDirectory!)
                    if(success){
                        isGoahead = true
                        requestJSON.setValue(Date().getJsonLogTime(), forKey: "CREATE_ZIP_END")
                        syncJSON.setValue("---Create Zip File End---", forKey: "4")
                    }else{
                        isGoahead = false
                        isGoaheadMessage = "Error creating zip"
                        syncJSON.setValue("---Failed to create zip file---", forKey: "8")
                    }
                }
                
                var fileData: NSData? = nil
                var fileData1:String  = ""
                do {
                    /******* HOME *******/
                    
                    var fileSizeValue: UInt64 = 0
                    do {
                        
                        let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: filePathToZip!)
                        
                        if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                            fileSizeValue = UInt64(truncating: fileNumberSize)
                            
                            let byteCountFormatter = ByteCountFormatter()
                            byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                            //print(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))
                            
                            requestJSON.setValue(zipName, forKey: "CREATE_ZIP_FILE_NAME")
                            syncJSON.setValue("---Create ZIP File Name---/\(zipName)", forKey: "5")
                            
                            requestJSON.setValue(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)), forKey: "CREATE_ZIP_SIZE")
                            syncJSON.setValue("---ZIP Size---/\(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))", forKey: "6")
                        }
                    } catch {
                        //print(error.localizedDescription)
                        syncJSON.setValue("---Failed to create zip file---", forKey: "8")
                    }
                    
                    try fileData = NSData(contentsOfFile: filePathToZip!, options: NSData.ReadingOptions.mappedIfSafe)
                    
                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                    /*********************/
                    //print(fileData)
                    //print(fileData1)
                }
                catch _ as NSError {
                    //print("Ooops! Something went wrong renamefile: \(error)")
                    isGoahead = false
                    isGoaheadMessage = "error:104"
                    syncJSON.setValue("---Failed to create zip file---", forKey: "8")
                }
                
                //returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 11,MAX: 25))"]
                //NotificationCenter.default.post(name: notificationName, object: nil)
                self.updateProgress(type: 1, message: "progress", min: 11, max: 20)
                
                if(isGoahead){
                    requestJSON.setValue(Date().getJsonLogTime(), forKey: "UPLOAD_API_CALL_START")
                    syncJSON.setValue("---Upload API call start---", forKey: "7")
                    
                    let web = urlUpload+uploadMethod

                    return UploadDatabaseFileZipOld(fileData1: fileData1, zipName: zipName, web: web, filePathTo: filePathTo!, fileManager: fileManager, databaseName: databaseName, action: "FileUpload")
                    
                    /*let parameters = [
                        "FileArray": "\(fileData1)",
                        "FileName": "\(zipName).zip",
                        "DeviceId": "\(imei)","PersonId": "\(fk_EmpGlCode)","Version": "\(version)","SubModuleName": "\(ClientName)","APIToken": "\(userName)",
                    ]
                    
                    //print(parameters)
                    self.startTimmerDetails(min: 25, max: 39)
                    
                    self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
                        
                        .responseString { response in
                            //print("Success: \(response.result)")
                            //print(response.timeline)
                            
                            switch response.result {
                            case .success(let jsonData):
                                //print("Success with JSON: \(jsonData)")
                                
                                /**** comment temp to check file ******/
                                // delete sync directory
                                if fileManager.fileExists(atPath: filePathTo!) {
                                    //print("FILE AVAILABLE")
                                    //var error: NSError?
                                    do {
                                        try fileManager.removeItem(atPath: filePathTo!)
                                    } catch let error as NSError {
                                        NSLog("delete directory \(error.debugDescription)")
                                        //FIRCrashMessage("delete directory:error:5")
                                    }
                                    
                                    self.createDirSyncDb(documentsPath: self.documentsPath)
                                    //createDirectory(documentsPath: documentsPath)
                                }
                                
                                
                                //print(jsonData)
                                do{
                                    //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 26,MAX: 40))"]
                                    //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                    self.stopTimer()
                                    self.updateProgress(type: 1, message: "progress", min: 40, max: 40)
                                    
                                    let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                                    
                                    let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]
                                    
                                    let anyObj = JSON(json)
                                    print("responce")
                                    print(anyObj)
                                    
                                    
                                    //print("**********************")
                                    //print("*******SYNC RESPONSE********")
                                    //print("**********************")
                                    //print(anyObj)
                                    //print("**********************")
                                    //print("**********************")
                                    //print("**********************")
                                    
                                    var isValid:String = ""
                                    var Message:String = ""
                                    var Message1:String = ""
                                    
                                    if anyObj["Status"].exists(){
                                        
                                        //print("inside Status")
                                        
                                        //let list: Array<JSON> = anyObj["Status"].arrayValue
                                        
                                        /*isValid = list[0]["isValid"].stringValue
                                         Message = list[0]["Message"].stringValue*/
                                        
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                        Message1 =  anyObj["Message"].stringValue
                                        
                                    }else{
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                        Message1 =  anyObj["Message"].stringValue
                                    }
                                    
                                    if anyObj["SyncId"].exists(){
                                        self.SyncId = anyObj["SyncId"].intValue
                                    }
                                    
                                    if(isValid.lowercased() == "1"){
                                        //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 41,MAX: 45))"]
                                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                        self.updateProgress(type: 1, message: "progress", min: 41, max: 41)
                                        if (self.isConnectedToNetwork() == true ){
                                            self.startTimmerDetails(min: 41, max: 55)
                                            self.downloadFile(urlStr: Message,zipFileName: "\(zipName).zip",databaseName: databaseName,Message: Message1)
                                        }else{
                                            isGoaheadMessage = "NO_INTERNET"
                                            //self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                            //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                        }
                                    }else{
                                        
                                        
                                        isGoaheadMessage = "server error:!, please try again \(anyObj)";
                                        //self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    }
                                }catch{
                                    isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                    //self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                    //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }
                                
                                
                                
                            case .failure(let error):
                                //print("Request failed with error: \(error)")
                                
                                let message = "# Oops something went wrong, please try again \(error)"
                                isGoaheadMessage = message;
                                //self.returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            }
                    }
                    
                    return isGoaheadMessage
                    */
                    
                }else{
                    //returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                    //NotificationCenter.default.post(name: notificationName, object: nil)
                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                    return isGoaheadMessage
                }
            }else{
                //returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
                //NotificationCenter.default.post(name: notificationName, object: nil)
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                return isGoaheadMessage
            }
        }else{
            //returnItems = ["type": "2","Details": "\(isGoaheadMessage)","progress": "0"]
            //NotificationCenter.default.post(name: notificationName, object: nil)
            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
            return isGoaheadMessage
        }
    }
    
    func requestJSONInString() -> String{
        let jsonData: NSData
        do {
            jsonData = try JSONSerialization.data(withJSONObject: requestJSON, options: JSONSerialization.WritingOptions()) as NSData
            return NSString(data: jsonData as Data, encoding: String.Encoding.utf8.rawValue)! as String
        } catch _ {
            print ("JSON Failure")
        }
        
        return ""
    }
    
    func syncJSONInString() -> String{
        let jsonData: NSData
        do {
            jsonData = try JSONSerialization.data(withJSONObject: syncJSON, options: JSONSerialization.WritingOptions()) as NSData
            return NSString(data: jsonData as Data, encoding: String.Encoding.utf8.rawValue)! as String
        } catch _ {
            print ("JSON Failure")
        }
        
        return ""
    }
    
    func UploadDatabaseFileZipOld(fileData1: String, zipName:String, web:String, filePathTo:String, fileManager:FileManager, databaseName:String, action:String) -> String{
        
        var isGoaheadMessage:String = "Done"
        
        syncJSON.setValue("---Convert DB File---", forKey: "12")
        
        let parameters = [
            "FileArray": "\(action == "Process" ? "" : "\(fileData1)")",
            "FileName": "\(zipName).zip",
            "DeviceId": "\(imei)",
            "PersonId": "\(fk_EmpGlCode)",
            "Version": "\(version)",
            "SubModuleName": "\(ClientName)",
            "APIToken": "\(userName)",
            
            "Action": "\(action)",
            "JsonData": "{\"Sync_Log\":[\"\(requestJSONInString())\"]}",
            "ExtraFields": "",
            "SyncId": "\(action == "Process" ? "\(self.SyncId)" : "")",
        ]
        
        
        if(action == "Process"){
            print(parameters)
        }
        
        if(action == "Process"){
            self.startTimmerDetails(min: 35, max: 59)
        }else{
            self.startTimmerDetails(min: 21, max: 34)
        }
        
        self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
            
            .responseString {
                
                response in
                switch response.result {
                case .success(let jsonData):
                    
                    if fileManager.fileExists(atPath: filePathTo) {
                        do {
                            try fileManager.removeItem(atPath: filePathTo)
                        } catch let error as NSError {
                            NSLog("delete directory \(error.debugDescription)")
                        }
                        
                        self.createDirSyncDb(documentsPath: self.documentsPath)
                    }
                    
                    do{
                        self.stopTimer()
                        if(action == "Process"){
                            self.updateProgress(type: 1, message: "progress", min: 60, max: 60)
                        }else{
                            self.updateProgress(type: 1, message: "progress", min: 35, max: 35)
                        }
                        
                        let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                        
                        let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]
                        
                        let anyObj = JSON(json)
                        print("responce")
                        print(anyObj)
                        
                        var isValid:String = ""
                        var Message:String = ""
                        var Message1:String = ""
                        
                        if anyObj["Status"].exists(){
                            isValid =  anyObj["Status"].stringValue
                            Message =  anyObj["Response"].stringValue
                            Message1 =  anyObj["Message"].stringValue
                        }else{
                            isValid =  anyObj["Status"].stringValue
                            Message =  anyObj["Response"].stringValue
                            Message1 =  anyObj["Message"].stringValue
                        }
                        
                        if anyObj["SyncId"].exists(){
                            self.SyncId = anyObj["SyncId"].intValue
                        }
                        
                        if(isValid.lowercased() == "1"){
                            
                            if(action == "Process"){
                                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "PROCESS_API_CALL_END")
                                self.syncJSON.setValue("---Process API Call End---", forKey: "16")
                                
                                //self.updateProgress(type: 1, message: "progress", min: 41, max: 41)
                                if (self.isConnectedToNetwork() == true ){
                                    self.startTimmerDetails(min: 61, max: 65)
                                    self.downloadFile(urlStr: Message,zipFileName: "\(zipName).zip",databaseName: databaseName,Message: Message1)
                                }else{
                                    isGoaheadMessage = "NO_INTERNET"
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }
                            }else{
                                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "UPLOAD_API_CALL_END")
                                self.syncJSON.setValue("---Upload API Call End---", forKey: "17")
                                
                                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "PROCESS_API_CALL_START")
                                self.syncJSON.setValue("---Process API Call Start---", forKey: "18")
                                
                                self.UploadDatabaseFileZipOld(fileData1: fileData1, zipName: zipName, web: web, filePathTo: filePathTo, fileManager: fileManager, databaseName: databaseName, action: "Process")
                                
                                
                            }
                        }else{
                            isGoaheadMessage = "server error:!, please try again \(anyObj)";
                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            self.syncJSON.setValue("---Response Error---\(anyObj)", forKey: "19")
                        }
                    }catch{
                        isGoaheadMessage = "server error:@, please try again \(jsonData)";
                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                        self.syncJSON.setValue("---Exception Error---\(jsonData)", forKey: "22")
                    }
                    
                case .failure(let error):
                    let message = "# Oops something went wrong, please try again \(error)"
                    isGoaheadMessage = message;
                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                    self.syncJSON.setValue("---API CALL FAIL---\(error)", forKey: "20")
                    
                    let httpStatusCode = response.response?.statusCode
                    self.syncJSON.setValue("---Response Status Not Getting 200---\(String(describing: httpStatusCode))", forKey: "21")
                    
                }
        }
        return isGoaheadMessage
    }
    
    func SyncDataForLAB(userName:String,fk_EmpGlCode:String,ClientName:String,version:String,imei:String,uploadMethod:String,urlUpload:String,databaseName:String, dbPassword:String, isDbEncripted:String)->String{
        
        self.userName=userName;
        self.fk_EmpGlCode=fk_EmpGlCode;
        self.ClientName=ClientName;
        self.version=version;
        self.imei=imei;
        self.uploadMethod=uploadMethod;
        self.logUploadMethod=urlUpload;
        self.urlUpload=urlUpload;
        
        print("*****************")
        print(logUploadMethod)
        print(uploadMethod)
        
        //returnItems = ["type": "1","Details": "progress","progress": "\(randomNumber(MIN: 1,MAX: 5))"]
        //NotificationCenter.default.post(name: notificationName, object: nil)
        self.updateProgress(type: 1, message: "progress", min: 1, max: 5)
        
        var isGoahead:Bool = true
        var isGoaheadMessage:String = ""
        
        let date = Date()
        let calendar = Calendar.current
        
        let year = calendar.component(.year, from: date)
        let month = calendar.component(.month, from: date)
        let day = calendar.component(.day, from: date)
        
        let hour = calendar.component(.hour, from: date)
        let minute = calendar.component(.minute, from: date)
        let second = calendar.component(.second, from: date)
        
        let dirName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        
        let fileName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_\(databaseName)"
        let zipName = "\(day)\(month)\(year)_\(hour)\(minute)\(second)_\(fk_EmpGlCode)_BASF-LAB-Database"
        self.zipNameFinal = zipName
        // App database path
        let filePathFrom = documentsPath.appendingPathComponent(databaseName)?.path
        let filePathTo = documentsPath.appendingPathComponent("SyncDatabase")?.path
        let filePathTo1 = documentsPath.appendingPathComponent("SyncDatabase/\(databaseName)")?.path
        let filePathTo2 = documentsPath.appendingPathComponent("SyncDatabase/\(fileName)")?.path
        let fileManager = FileManager.default
        
        //createDirSyncDb(documentsPath)
        
        if fileManager.fileExists(atPath: filePathTo!) {
            do {
                try fileManager.removeItem(atPath: filePathTo!)
            } catch let error as NSError {
                NSLog("delete directory \(error.debugDescription)")
                isGoahead = false;
                isGoaheadMessage = "error:101";
                
            }
            createDirSyncDb(documentsPath: documentsPath)
        } else {
            createDirSyncDb(documentsPath: documentsPath)
        }
        
        if(isGoahead){
            if fileManager.fileExists(atPath: filePathTo1!) {
                //print("filePathTo1 exist")
            }
            if fileManager.fileExists(atPath: filePathTo2!) {
                //print("filePathTo2 exist")
            }
            //databaseName = "BASF-HK-Database"
            let filePathToZip = documentsPath.appendingPathComponent("SyncDatabase/\(zipName).zip")?.path
            
            let newDirectory = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)")?.path
            
            let newDirectory1 = documentsPath.appendingPathComponent("SyncDatabase/\(dirName)/\(fileName)")?.path
            
            do {
                try fileManager.createDirectory(atPath: newDirectory!, withIntermediateDirectories: false, attributes: nil)
            } catch let error as NSError {
                isGoahead = false;
                isGoaheadMessage = "error:103 \(error)";
            }
            
            //copy from SyncDatabase to document
            if fileManager.fileExists(atPath: filePathFrom!) {
                do {
                    try fileManager.copyItem(atPath: filePathFrom!, toPath: newDirectory1!)
                } catch let error as NSError {
                    NSLog("Unable to copy file \(error.debugDescription)")
                    //print("Ooops! Something went wrong copyItem: \(error)")
                    isGoahead = false;
                    isGoaheadMessage = "error:103";
                }
            }
            
            self.updateProgress(type: 1, message: "progress", min: 6, max: 10)
            
            if(isGoahead){
                
                if(isDbEncripted == "true"){
                    let success = SSZipArchive.createZipFile(atPath: filePathToZip!,
                                                             withContentsOfDirectory: newDirectory!,
                                                             keepParentDirectory: false,
                                                             compressionLevel: 5,
                                                             password: ZipPassword,
                                                             aes: true,
                                                             progressHandler: nil)
                    if(success){
                        isGoahead = true
                    }else{
                        isGoahead = false
                        isGoaheadMessage = "Error creating zip"
                    }
                }else{
                    let success = SSZipArchive.createZipFile(atPath: filePathToZip!, withContentsOfDirectory: newDirectory!)
                    if(success){
                        isGoahead = true
                    }else{
                        isGoahead = false
                        isGoaheadMessage = "Error creating zip"
                    }
                }
                
                var fileData: NSData? = nil
                var fileData1:String  = ""
                do {
                    var fileSizeValue: UInt64 = 0
                    do {
                        
                        let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: filePathToZip!)
                        
                        if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                            fileSizeValue = UInt64(fileNumberSize)
                            
                            let byteCountFormatter = ByteCountFormatter()
                            byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                            //print(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))
                            
                        }
                        
                    } catch {
                        //print(error.localizedDescription)
                    }
                    
                    try fileData = NSData(contentsOfFile: filePathToZip!, options: NSData.ReadingOptions.mappedIfSafe)
                    
                    fileData1 = fileData!.base64EncodedString(options: NSData.Base64EncodingOptions([]))
                }
                catch let error as NSError {
                    isGoahead = false;
                    isGoaheadMessage = "error:104";
                }
                self.updateProgress(type: 1, message: "progress", min: 11, max: 25)
                
                if(isGoahead){
                    let web = urlUpload+uploadMethod
                    let parameters = [
                        "FileArray": "\(fileData1)",
                        "FileName": "\(zipName).zip",
                        "DeviceId": "\(imei)","PersonId": "\(fk_EmpGlCode)","Version": "\(version)","SubModuleName": "\(ClientName)","APIToken": "\(userName)",
                    ]
                    
                    //print(parameters)
                    self.startTimmerDetails(min: 25, max: 39)
                    
                    self.alamofireManager!.request(web, method: .post, parameters: parameters).validate(statusCode: 200..<300)
                        
                        .responseString { response in
                            
                            switch response.result {
                            case .success(let jsonData):
                                if fileManager.fileExists(atPath: filePathTo!) {
                                    do {
                                        try fileManager.removeItem(atPath: filePathTo!)
                                    } catch let error as NSError {
                                        NSLog("delete directory \(error.debugDescription)")
                                    }
                                    
                                    self.createDirSyncDb(documentsPath: self.documentsPath)
                                }
                                
                                
                                do{
                                    self.stopTimer()
                                    self.updateProgress(type: 1, message: "progress", min: 40, max: 40)
                                    
                                    let data: NSData = jsonData.data(using: String.Encoding.utf8)! as NSData
                                    
                                    let json = try JSONSerialization.jsonObject(with: data as Data, options: []) as? [String : Any]
                                    
                                    let anyObj = JSON(json)
                                    print("responce")
                                    print(anyObj)
                                    
                                    var isValid:String = ""
                                    var Message:String = ""
                                    var Message1:String = ""
                                    
                                    if anyObj["Status"].exists(){
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                        Message1 =  anyObj["Message"].stringValue
                                        
                                    }else{
                                        isValid =  anyObj["Status"].stringValue
                                        Message =  anyObj["Response"].stringValue
                                        Message1 =  anyObj["Message"].stringValue
                                    }
                                    
                                    if anyObj["SyncId"].exists(){
                                        self.SyncId = anyObj["SyncId"].intValue
                                    }
                                    
                                    if(isValid.lowercased() == "1"){
                                        self.updateProgress(type: 1, message: "progress", min: 41, max: 41)
                                        if (self.isConnectedToNetwork() == true ){
                                            self.startTimmerDetails(min: 41, max: 55)
                                            self.downloadFile(urlStr: Message,zipFileName: "\(zipName).zip",databaseName: databaseName,Message: Message1)
                                        }else{
                                            isGoaheadMessage = "NO_INTERNET"
                                            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                        }
                                    }else{
                                        isGoaheadMessage = "server error:!, please try again \(anyObj)";
                                        self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                    }
                                }catch{
                                    isGoaheadMessage = "server error:@, please try again \(jsonData)";
                                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                                }
                                
                                
                                
                            case .failure(let error):
                                let message = "# Oops something went wrong, please try again \(error)"
                                isGoaheadMessage = message;
                                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                            }
                    }
                    
                    return isGoaheadMessage
                    
                }else{
                    self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                    return isGoaheadMessage
                }
            }else{
                self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
                return isGoaheadMessage
            }
        }else{
            self.updateProgress(type: 2, message: isGoaheadMessage, min: 0, max: 0)
            return isGoaheadMessage
        }
    }
    
    func downloadFile(urlStr:String, zipFileName:String,databaseName:String,Message:String){
        
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm:ss"
        
        let destination: DownloadRequest.DownloadFileDestination = { _, _ in
            let documentsURL = FileManager.default.urls(for: .documentDirectory, in: .userDomainMask)[0]
            let fileURL = documentsURL.appendingPathComponent("SyncDatabase/Download/\(zipFileName)")
            
            return (fileURL, [.removePreviousFile, .createIntermediateDirectories])
        }
        
        self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_START")
        self.syncJSON.setValue("---Download DB Start---", forKey: "23")
        
        Alamofire.download(urlStr, to: destination).response { response in
            //print(response)
            
            if response.error == nil, let imagePath = response.destinationURL?.path {
                //let image = UIImage(contentsOfFile: imagePath)
                
                //print(imagePath)
                //end - diff
                //let dateFormatter = DateFormatter()
                //dateFormatter.dateFormat = "HH:mm:ss"
                //let diff = self.getDiffTime(time2: Date())
                //self.data_createJson.setValue("\(diff)", forKey: "9_DOWNLOAD_END")
                
                //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 46,MAX: 60))"]
                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                self.stopTimer()
                self.updateProgress(type: 1, message: "progress", min: 65, max: 68)
                
                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "DOWNLOAD_END")
                self.syncJSON.setValue("---Download DB End---", forKey: "24")

                
                var fileSizeValue: UInt64 = 0
                
                do {
                    let fileAttribute: [FileAttributeKey : Any] = try FileManager.default.attributesOfItem(atPath: imagePath)
                    
                    if let fileNumberSize: NSNumber = fileAttribute[FileAttributeKey.size] as? NSNumber {
                        fileSizeValue = UInt64(fileNumberSize)
                        
                        //let byteCountFormatter = ByteCountFormatter()
                        //byteCountFormatter.allowedUnits = ByteCountFormatter.Units.useKB
                        //print(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))
                        
                        //self.data_createJson.setValue("\(byteCountFormatter.string(fromByteCount: Int64(fileSizeValue)))", forKey: "9_DOWNLOAD_FILE_SIZE")
                    }
                } catch {
                    print(error.localizedDescription)
                    self.syncJSON.setValue("---9_DOWNLOAD_END_FAIL---\(error.localizedDescription)", forKey: "36")
                }
                
                self.unzipDirectory(unZipFile: zipFileName,databaseName: databaseName,Message: Message)
                
            }else{
                self.syncJSON.setValue("---6_DOWNLOAD_END_FAIL---", forKey: "37")
            }
        }
    }
    
    func unzipDirectory(unZipFile:String,databaseName:String,Message:String){
        // unzip & copy
        
        DispatchQueue.main.async {
            
            //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 61,MAX: 74))"]
            //NotificationCenter.default.post(name: self.notificationName, object: nil)
            self.updateProgress(type: 1, message: "progress", min: 69, max: 73)
            
            self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "IMPORT_FILE_START")
            self.syncJSON.setValue("---Import File Start---", forKey: "25")
            
            let fileManager = FileManager.default
            
            let documentsPath = NSURL(fileURLWithPath: NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true)[0])
            let filePathToZip = documentsPath.appendingPathComponent("SyncDatabase/Download/\(unZipFile)")?.path
            let filePathfromZip = documentsPath.appendingPathComponent("SyncDatabase")?.path
            //let oldDBName = documentsPath.appendingPathComponent("SyncDatabase/\(self.zipNameFinal.lowercased()).db")?.path
            let oldDBName = documentsPath.appendingPathComponent("SyncDatabase/\(self.zipNameFinal).db")?.path
            let newDBName = documentsPath.appendingPathComponent("SyncDatabase/\(databaseName)")?.path
            
            let documentDBName = documentsPath.appendingPathComponent("\(databaseName)")?.path
            
            //print("********************")
            //print(filePathToZip)
            //print(filePathfromZip)
            //print(oldDBName)
            //print(newDBName)
            //print(documentDBName)
            //print("********************")
            
            
            //print("1 --> \(filePathToZip)")
            // print("2 --> \(filePathfromZip)")
            var fileUnZip:Bool = false
            var s:Bool = false
            
            self.syncJSON.setValue("---Unzip File Start---", forKey: "26")
            
            let success = SSZipArchive.isFilePasswordProtected(atPath: filePathToZip!)
            if success {
                print("Yes, it's password protected.")
                //info.text = "Yes, it's password protected."
                
                s   = SSZipArchive.unzipFile(atPath: filePathToZip!,
                                             toDestination: filePathfromZip!,
                                             preserveAttributes: true,
                                             overwrite: true,
                                             nestedZipLevel: 1,
                                             password: self.ZipPassword,
                                             error: nil,
                                             delegate: nil,
                                             progressHandler: nil,
                                             completionHandler: nil)
            } else {
                print("No, it's not password protected.")
                //info.text = "No, it's not password protected."
                s =  SSZipArchive.unzipFile(atPath: filePathToZip!, toDestination: filePathfromZip!)
            }
            
           
            
            //let s:Bool =  SSZipArchive.unzipFile(atPath: filePathToZip!, toDestination: filePathfromZip!)
            if(s){
                fileUnZip = true
                print("unzip zip file")
                 self.syncJSON.setValue("---Unzip File END---", forKey: "27")
            }else{
                fileUnZip = false
                print("not unzip zip file")
                self.syncJSON.setValue("---Unzip File FAILED---", forKey: "28")
            }
            
            //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 75,MAX: 84))"]
            //NotificationCenter.default.post(name: self.notificationName, object: nil)
            self.updateProgress(type: 1, message: "progress", min: 74, max: 80)
            
            if(fileUnZip){
                // rename file
                //print("3 --> \(oldDBName)")
                //print("4 --> \(newDBName)")
                
                //print("oldDBName:\(oldDBName)")
                //print("newDBName:\(newDBName)")
                //print("documentDBName:\(documentDBName)")
                
                if fileManager.fileExists(atPath: oldDBName!) {
                    
                    do {
                        try fileManager.moveItem(atPath: oldDBName!, toPath: newDBName!)
                    }
                    catch let error as NSError {
                        //print("Ooops! Something went wrong renamefile: \(error)")
                        //self.data_createJson.setValue("error", forKey: "RESTORE_DB_END_FAIL_10")
                        //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 1 \(error)","progress": "0"]
                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                        self.updateProgress(type: 2, message: "Ooops! Something went wrong 1", min: 0, max: 0)
                    }
                }
                
                if fileManager.fileExists(atPath: documentDBName!) {
                    do {
                        try fileManager.removeItem(atPath: documentDBName!)
                    } catch let error as NSError {
                        //print("error delete file \(error.debugDescription)")
                        //self.data_createJson.setValue("error", forKey: "RESTORE_DB_END_FAIL_10")
                        //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 2 \(error)","progress": "0"]
                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                        self.updateProgress(type: 2, message: "Ooops! Something went wrong 2", min: 0, max: 0)
                        self.syncJSON.setValue("---Move Item Failed---", forKey: "29")
                    }
                }
                
                self.updateProgress(type: 1, message: "progress", min: 81, max: 83)
                
                //print("5 --> \(newDBName)")
                //print("6 --> \(documentDBName)")
                
                //copy from SyncDatabase to document
                
                if fileManager.fileExists(atPath: newDBName!) {
                    do {
                        //restor starts
                        let dateFormatter = DateFormatter()
                        dateFormatter.dateFormat = "HH:mm:ss"
                        
                        
                        /*if fileManager.fileExists(atPath: newDBName!) {
                            
                            //print(newDBName)
                        }
                        
                        //print(documentDBName)
                        
                        if fileManager.fileExists(atPath: documentDBName!) {
                            
                            //print(documentDBName)
                        }*/
                        
                        
                        try fileManager.copyItem(atPath: newDBName!, toPath: documentDBName!)
                    } catch let error as NSError {
                        NSLog("Unable to copy file \(error.debugDescription)")
                        //self.data_createJson.setValue("error)", forKey: "10_RESTORE_DB_END_FAIL")
                        //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 3","progress": "0"]
                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                        self.updateProgress(type: 2, message: "Ooops! Something went wrong 3", min: 0, max: 0)
                        self.syncJSON.setValue("---Copy File Failed---", forKey: "30")
                    }
                }else{
                    //print("newDBName:\(newDBName)")
                    
                    //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 4","progress": "0"]
                    //NotificationCenter.default.post(name: self.notificationName, object: nil)
                    self.updateProgress(type: 2, message: "Ooops! Something went wrong 4", min: 0, max: 0)
                }
                
                //sleep(200)
                
                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "IMPORT_FILE_END")
                self.syncJSON.setValue("---Import File End---", forKey: "31")

                
                let filePathTo = documentsPath.appendingPathComponent("SyncDatabase")?.path
                // delete sync directory
                if fileManager.fileExists(atPath: filePathTo!) {
                    //print("FILE AVAILABLE")
                    //var error: NSError?
                    do {
                        try fileManager.removeItem(atPath: filePathTo!)
                    } catch let error as NSError {
                        NSLog("delete directory \(error.debugDescription)")
                        //self.data_createJson.setValue("error", forKey: "10_RESTORE_DB_END_FAIL")
                        //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong 5","progress": "0"]
                        //NotificationCenter.default.post(name: self.notificationName, object: nil)
                        self.updateProgress(type: 2, message: "Ooops! Something went wrong 5", min: 0, max: 0)
                    }
                    
                    //self.createDirectory(documentsPath)
                }
                
                
                
                //sleep(10)
                
                //DispatchQueue.main.async {
                //self.returnItems = ["type": "1","Details": "progress","progress": "\(self.randomNumber(MIN: 85,MAX: 97))"]
                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                self.updateProgress(type: 1, message: "progress", min: 85, max: 97)
                // }
                
                //s//leep(1)
                
                //self.callUpload(urlUpload: self.urlUpload, logUploadMethod: self.logUploadMethod, fk_EmpGlCode: self.fk_EmpGlCode, SyncId: self.SyncId, DeviceSyncStatus: "Y", DeviceSyncJson: "Y", ClientName: self.ClientName, imei: self.imei, version: self.version, userName: self.userName)
                
                // DispatchQueue.main.async {
                //self.returnItems = ["type": "3","Details": "Sync Successfully Done","progress": "100"]
                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                // }
                self.requestJSON.setValue(Date().getJsonLogTime(), forKey: "SYNC_END")
                self.syncJSON.setValue("---Sync End---", forKey: "32")

                self.updateProgress(type: 3, message: Message, min: 100, max: 100)
                
                
                //dispatch_async(dispatch_get_main_queue()) {
                
                //self.currentDateDB = ECP_Constant.checkFlagLableMaser("SYNCDATE");
                
                //self.isAllowCheck = ECP_Constant.checkFlagLableMaserBool("CheckReviewOnVisit");
                
                
                
                /*let date = Date()
                 let calendar = Calendar.current
                 
                 let year = calendar.component(.year, from: date)
                 let month = calendar.component(.month, from: date)
                 let day = calendar.component(.day, from: date)
                 
                 let hour = calendar.component(.hour, from: date)
                 let minute = calendar.component(.minute, from: date)
                 let second = calendar.component(.second, from: date)
                 
                 self.isallowflag = self.checkDate(isFirst: false)
                 
                 let defaults = UserDefaults.standard
                 defaults.set(NSDate(), forKey: ECP_Constant.VAR_LAST_SYNC_TIME_DATE);*/
                
                //ECP_Constant.IS_VALID_LOGIN)
                
                /* var i:Int = 0
                 while (i<10000) {
                 i = i + 1
                 }*/
                
                //sleep(500)
                
                //end
                // let dateFormatter = DateFormatter()
                // dateFormatter.dateFormat = "HH:mm:ss"
                
                //let diff = self.getDiffTime(time2: Date())
                
                //self.data_createJson.setValue("\(diff)", forKey: "11_RESTORE_DB_END")
                
                //let diff2 = self.getEndTimeDiff(time2: timeStart)
                //self.data_createJson.setValue("\(diff2)", forKey: "12_END")
                
                //self.MessageLastSync(msg: "Sync Successfully Done")
                //let varLastSyncTime:String = "\(day)/\(month)/\(year) \(hour):\(DBAdapter.addZero(value: minute)):\(second)"
                //let defaults = NSUserDefaults.standardUserDefaults()
                //defaults.setValue(varLastSyncTime, forKey: ECP_Constant.VAR_LAST_SYNC_TIME)
                //self.setSyncTime()
                //self.getModuleList()
                //}
            }else{
                //dispatch_async(dispatch_get_main_queue()) {
                //self.showAlertMessageSync(messageM: "Ooops! Something went wrong")
                //}
                
                //self.returnItems = ["type": "2","Details": "Ooops! Something went wrong","progress": "0"]
                //NotificationCenter.default.post(name: self.notificationName, object: nil)
                self.updateProgress(type: 2, message: "Ooops! Something went wrong", min: 0, max: 0)
            }
        }
    }
    
    func randomNumber(MIN: Int, MAX: Int)-> Int{
        return Int(arc4random_uniform(UInt32(MAX-MIN)) + UInt32(MIN));
    }
    
    func createDirSyncDb(documentsPath:NSURL){
        let logsPath = documentsPath.appendingPathComponent("SyncDatabase")
        do {
            try FileManager.default.createDirectory(atPath: logsPath!.path, withIntermediateDirectories: true, attributes: nil)
        } catch let error as NSError {
            NSLog("Unable to create directory \(error.debugDescription)")
        }
    }
    
    func createDir(path:NSURL){
        do {
            try FileManager.default.createDirectory(atPath: path.path!, withIntermediateDirectories: true, attributes: nil)
        } catch let error as NSError {
            NSLog("Unable to create directory \(error.debugDescription)")
        }
    }
    
    func deleteDir(path:NSURL) -> Bool{
        if FileManager.default.fileExists(atPath: path.path!){
            do {
                try FileManager.default.removeItem(atPath: path.path!)
            } catch let error as NSError {
                NSLog("delete directory \(path) \(error.debugDescription)")
                return false
            }
        }
        return true
    }
    
    func deleteDirNew(path:NSURL) {
        if FileManager.default.fileExists(atPath: path.path!){
            do {
                try FileManager.default.removeItem(atPath: path.path!)
            } catch let error as NSError {
                NSLog("delete directory \(path) \(error.debugDescription)")
                //return false
            }
        }
        // return true
    }
    
    func isConnectedToNetwork() -> Bool {
        
        var zeroAddress = sockaddr_in(sin_len: 0, sin_family: 0, sin_port: 0, sin_addr: in_addr(s_addr: 0), sin_zero: (0, 0, 0, 0, 0, 0, 0, 0))
        zeroAddress.sin_len = UInt8(MemoryLayout.size(ofValue: zeroAddress))
        zeroAddress.sin_family = sa_family_t(AF_INET)
        
        let defaultRouteReachability = withUnsafePointer(to: &zeroAddress) {
            $0.withMemoryRebound(to: sockaddr.self, capacity: 1) {zeroSockAddress in
                SCNetworkReachabilityCreateWithAddress(nil, zeroSockAddress)
            }
        }
        
        var flags: SCNetworkReachabilityFlags = SCNetworkReachabilityFlags(rawValue: 0)
        if SCNetworkReachabilityGetFlags(defaultRouteReachability!, &flags) == false {
            return false
        }
        
        /* Only Working for WIFI
         let isReachable = flags == .reachable
         let needsConnection = flags == .connectionRequired
         
         return isReachable && !needsConnection
         */
        
        // Working for Cellular and WIFI
        let isReachable = (flags.rawValue & UInt32(kSCNetworkFlagsReachable)) != 0
        let needsConnection = (flags.rawValue & UInt32(kSCNetworkFlagsConnectionRequired)) != 0
        let ret = (isReachable && !needsConnection)
        
        return ret
        
    }
    
    func getDeviceUniqueNo()->String{
        let udifstr = UIDevice.current.identifierForVendor!.uuidString
        let mili:Int64 = getCurrentMillis()
        let rand:Int64 = getRandomNumber()
        let iint:Int = "\(mili)".count
        let iii = udifstr + "\(iint)" + "\(rand)";
        //print(iii)
        return iii
    }
    
    func getCurrentMillis()->Int64 {
        return Int64(Date().timeIntervalSince1970 * 1000)
    }
    
    func getRandomNumber()->Int64 {
        let number = floor(Double(arc4random_uniform(1000) * 6000)) + 1000
        return Int64(number)
    }
    
    var timer: Timer?
    var mMin:Int = 0
    var mMax:Int = 0
    
    func startTimer() {
        
        if timer == nil {
            timer = Timer.scheduledTimer(timeInterval: 10, target: self, selector: #selector(self.loop), userInfo: nil, repeats: true)
        }
    }
    
    func stopTimer() {
        if timer != nil {
            timer?.invalidate()
            timer = nil
        }
    }
    
    func startTimmerDetails(min:Int,max:Int){
        stopTimer()
        mMin = min
        mMax = max
        startTimer()
    }
    
    @objc func loop() {
        if(mMin < mMax){
            mMin = mMin + 1
        }
        returnItems = ["type": "1","Details": "Update Progress Auto","progress": "\(mMin)"]
        NotificationCenter.default.post(name: notificationName, object: nil)
    }
}

/*extension Range
 {
 var randomInt: Int
 {
 get
 {
 var offset = 0
 
 if (startIndex as Int) < 0   // allow negative ranges
 {
 offset = abs(startIndex as Int)
 }
 
 let mini = UInt32(startIndex as Int + offset)
 let maxi = UInt32(endIndex   as Int + offset)
 
 return Int(mini + arc4random_uniform(maxi - mini)) - offset
 }
 }
 }*/

extension String {
    func aesEncrypt(key: String, iv: String) throws -> String{
        //let data = self.dataUsingEncoding(NSUTF8StringEncoding)
        let data1 = self.data(using: .utf8)
        let enc = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).encrypt(data1!.bytes)
        let encData = NSData(bytes: enc, length: Int(enc.count))
        let base64String: String = encData.base64EncodedString(options: NSData.Base64EncodingOptions(rawValue: 0));
        let result = String(base64String)
        return result
    }
    
    func aesDecrypt(key: String, iv: String) throws -> String {
        // let data1 = NSData(base64Encoded: self.data(using: .utf8)!, options: NSData.Base64DecodingOptions(rawValue: 0))
        let data1 = Data(base64Encoded: self)!
        let dec = try AES(key: key, iv: iv, blockMode:.CBC).decrypt(Array(data1))
        let decData = NSData(bytes: dec, length: Int(dec.count))
        let result = NSString(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
        return String(result!)
    }
}

extension String {
    /*func aesEncrypt(key: String, iv: String) throws -> String{
     //let data = self.dataUsingEncoding(NSUTF8StringEncoding)
     let data1 = self.data(using: .utf8)
     let enc = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).encrypt(data1!.bytes)
     let encData = NSData(bytes: enc, length: Int(enc.count))
     let base64String: String = encData.base64EncodedString(options: NSData.Base64EncodingOptions(rawValue: 0));
     let result = String(base64String)
     return result
     }
     
     func aesDecrypt(key: String, iv: String) throws -> String {
     //let data1 = NSData(base64Encoded: self, options: NSData.Base64DecodingOptions(rawValue: 0))
     let data1 = Data(base64Encoded: self)!
     let dec = try AES(key: key, iv: iv, blockMode:.CBC,padding: .pkcs7).decrypt(Array(data1))
     let decData = NSData(bytes: dec, length: Int(dec.count))
     let result = NSString(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
     //let result = String(bytes: Data(decData).bytes, encoding: .utf8)
     print(decData)
     //let result =  String(data: decData as Data, encoding: String.Encoding.utf8.rawValue)
     return String(result!)
     }*/
    
    /* let key = "B4V2A1C@S#S$F"
     let iv = "0000000000000000"
     let s = "Vcs@1234"
     let enc = try! s.aesEncrypt1(key: key, iv: iv)
     print(enc)
     
     do{
     let dec = try enc.aesDecrypt1(key: key, iv: iv)
     print("dec:\(dec)")
     print("\(s == dec)")
     
     }catch let error {
     print("error:\(error)")
     }*/
    
    func aesEncrypt1(key: String, iv: String) throws -> String {
        
        
        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }
        
        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }
        
        let key1 = keyBytes
        let iv1 = keyBytes
        
        let encrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).encrypt([UInt8](self.data(using: .utf8)!))
        return Data(encrypted).base64EncodedString()
    }
    
    func aesDecrypt1(key: String, iv: String) throws -> String {
        
        let pwdBytes = [UInt8](key.utf8)
        var keyBytes: [UInt8] = Array(arrayLiteral: 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
        var len = pwdBytes.count
        if(len > keyBytes.count){
            len = keyBytes.count
            //keyBytes = NSArray(array:b, copyItems: true) as! [UInt8]
        }
        
        var i:Int = 0
        while(i < len){
            keyBytes[i] = pwdBytes[i]
            i = i + 1
        }
        
        let key1 = keyBytes
        let iv1 = keyBytes
        
        guard let data = Data(base64Encoded: self) else { return "" }
        let decrypted = try AES(key: key1, iv: iv1, blockMode:.CBC, padding: .pkcs5).decrypt([UInt8](data))
        return String(bytes: Data(decrypted).bytes, encoding: .utf8) ?? "Could not decrypt"
    }
    
}

extension String {
    
    func toDate() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }
    
    func toServerDateUTC() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "UTC") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }
    
    func toEntryDDate() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }
    
    func toEntryDDateUTC1() -> Date {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.timeZone = TimeZone(abbreviation: "UTC") //Current time zone
        let date = dateFormatter.date(from: self)
        return date!
    }
    
    
    func toConvertTimeAMPM() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss" //Your date format
        dateFormatter.locale = Locale(identifier: "en_US_POSIX")
        
        //        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date = dateFormatter.date(from: self)
        
        let dateFormatter1 = DateFormatter()
        dateFormatter1.dateFormat = "hh:mm:ss a" //Your date format
        dateFormatter1.locale = Locale(identifier: "en_US_POSIX")
        
        //        dateFormatter1.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        let date2 = dateFormatter1.string(from: date!)
        
        return date2
    }
    
    //    func toShowTimeAMPM() -> String {
    //        let dateFormatter1 = DateFormatter()
    //        dateFormatter1.dateFormat = "hh:mm:ss a" //Your date format
    //        dateFormatter1.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
    //        let date2 = dateFormatter1.string(from: dateFormatter1.date(from: self)!)
    //
    //        return date2
    //    }
    
    
    func replace(target: String, withString: String) -> String
    {
        return self.replacingOccurrences(of: target, with: withString, options: NSString.CompareOptions.literal, range: nil)
    }
}

extension Date {
    
    func monthsFromDate(from date: Date) -> Int {
        return Calendar.current.dateComponents([.month], from: date, to: self).month ?? 0
    }
    
    func toDayNameString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "EEEE"
        let str = dateFormatter.string(from: self)
        let index = str.index(str.startIndex, offsetBy: 3)
        return str.substring(to: index)
        //return String(str[index])
        //return mySubstring
    }
    
    func toDayString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "EEEE"
        return dateFormatter.string(from: self)
    }
    
    func toPlanStringGMT() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd"
        dateFormatter.timeZone = TimeZone(abbreviation: "GMT+0:00") //Current time zone
        
        return dateFormatter.string(from: self)
    }
    
    func toPlanString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd"
        return dateFormatter.string(from: self)
    }
    
    func toPlanShowMonthString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "dd-MMM-yyyy"
        return dateFormatter.string(from: self)
    }
    
    func toShowTimeAMPM() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "hh:mm a"
        return dateFormatter.string(from: self)
    }
    
    func toTime24Hours() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm"
        return dateFormatter.string(from: self)
    }
    
    func toPlanShowString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "dd-MM-yyyy"
        return dateFormatter.string(from: self)
    }
    
    func toEntryDate() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        return dateFormatter.string(from: self)
    }
    
    func toMyFormatDate(format:String) -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = format
        return dateFormatter.string(from: self)
    }
    
    func toEntryTime() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "HH:mm:ss"
        dateFormatter.locale = Locale(identifier: "en_US_POSIX")
        
        return dateFormatter.string(from: self)
    }
    
    func toMonth() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.month, from: self)
        return month
    }
    
    func toDay() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.day, from: self)
        return month
    }
    
    func toHour() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.hour, from: self)
        return month
    }
    
    func toMinute() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.minute, from: self)
        return month
    }
    
    //let dateFormatter = DateFormatter()
    //dateFormatter.dateFormat = "MMM-YYYY"
    
    func toMonthYearString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMM-YYYY"
        return dateFormatter.string(from: self)
    }
    
    func toFullMonthYearString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMMM-YYYY"
        return dateFormatter.string(from: self)
    }
    
    func toFullYearString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "YYYY"
        return dateFormatter.string(from: self)
    }
    
    func toMonthString() -> String {
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMMM"
        return dateFormatter.string(from: self)
    }
    
    func toYear() -> Int {
        let calendar = Calendar.current
        let month = calendar.component(.year, from: self)
        return month
    }
    
    func addRemoveYear(month1:Int)->Date{
        return Calendar.current.date(byAdding: .year, value: month1, to: self)!
    }
    
    func addRemoveMonth(month1:Int)->Date{
        return Calendar.current.date(byAdding: .month, value: month1, to: self)!
    }
    
    func addRemoveDay(month1:Int)->Date{
        return Calendar.current.date(byAdding: .day, value: month1, to: self)!
    }
    
    
    /*func startOfMonth() -> Date {
     return Calendar.current.date(from: Calendar.current.dateComponents([.year, .month], from: Calendar.current.startOfDay(for: self)))!
     }
     
     func endOfMonth() -> Date {
     return Calendar.current.date(byAdding: DateComponents(month: 1, day: -1), to: self.startOfMonth())!
     }*/
    
    func startOfMonth() -> Date {
        
        let calendar = Calendar.current
        let currentDateComponents = calendar.dateComponents([.year, .month], from: self)
        let startOfMonth = calendar.date(from: currentDateComponents)
        
        return startOfMonth!
    }
    
    func dateByAddingMonths(_ monthsToAdd: Int) -> Date? {
        
        let calendar = Calendar.current
        var months = DateComponents()
        months.month = monthsToAdd
        
        return calendar.date(byAdding: months, to: self)
    }
    
    func endOfMonth() -> Date {
        
        let plusOneMonthDate = dateByAddingMonths(1)
        
        let calendar = Calendar.current
        let plusOneMonthDateComponents = calendar.dateComponents([.year, .month], from: plusOneMonthDate!)
        let endOfMonth = calendar.date(from: plusOneMonthDateComponents)?.addingTimeInterval(-1)
        
        return endOfMonth!
        
    }
    
    func dayOfTheWeek() -> String? {
        let weekdays = [
            "Sunday",
            "Monday",
            "Tuesday",
            "Wednesday",
            "Thursday",
            "Friday",
            "Saturday"
        ]
        
        let calendar = Calendar.current
        let components = calendar.dateComponents([.weekday], from: self)
        return weekdays[components.weekday! - 1]
    }
    
    func getJsonLogTime() -> String {
        let formatter = DateFormatter()
        formatter.dateFormat = "yyyy-MM-dd HH:mm:ss"
        return formatter.string(from: self)
    }
    
}

extension String {
    func fileName() -> String {
        return URL(fileURLWithPath: self).deletingPathExtension().lastPathComponent
    }
    
    func fileExtension() -> String {
        return URL(fileURLWithPath: self).pathExtension
    }
}

public class Reachability {
    
    class func isConnectedToNetwork() -> Bool {
        
        var zeroAddress = sockaddr_in(sin_len: 0, sin_family: 0, sin_port: 0, sin_addr: in_addr(s_addr: 0), sin_zero: (0, 0, 0, 0, 0, 0, 0, 0))
        zeroAddress.sin_len = UInt8(MemoryLayout.size(ofValue: zeroAddress))
        zeroAddress.sin_family = sa_family_t(AF_INET)
        
        let defaultRouteReachability = withUnsafePointer(to: &zeroAddress) {
            $0.withMemoryRebound(to: sockaddr.self, capacity: 1) {zeroSockAddress in
                SCNetworkReachabilityCreateWithAddress(nil, zeroSockAddress)
            }
        }
        
        var flags: SCNetworkReachabilityFlags = SCNetworkReachabilityFlags(rawValue: 0)
        if SCNetworkReachabilityGetFlags(defaultRouteReachability!, &flags) == false {
            return false
        }
        
        /* Only Working for WIFI
         let isReachable = flags == .reachable
         let needsConnection = flags == .connectionRequired
         
         return isReachable && !needsConnection
         */
        
        // Working for Cellular and WIFI
        let isReachable = (flags.rawValue & UInt32(kSCNetworkFlagsReachable)) != 0
        let needsConnection = (flags.rawValue & UInt32(kSCNetworkFlagsConnectionRequired)) != 0
        let ret = (isReachable && !needsConnection)
        
        return ret
        
    }
}

extension Character {
    var isAscii: Bool {
        return unicodeScalars.allSatisfy { $0.isASCII }
    }
    var ascii: UInt32? {
        return isAscii ? unicodeScalars.first?.value : nil
    }
}

extension String {
    
    var length: Int {
        return count
    }
    
    subscript (i: Int) -> String {
        return self[i ..< i + 1]
    }
    
    func substring(fromIndex: Int) -> String {
        return self[min(fromIndex, length) ..< length]
    }
    
    func substring(toIndex: Int) -> String {
        return self[0 ..< max(0, toIndex)]
    }
    
    subscript (r: Range<Int>) -> String {
        let range = Range(uncheckedBounds: (lower: max(0, min(length, r.lowerBound)),
                                            upper: min(length, max(0, r.upperBound))))
        let start = index(startIndex, offsetBy: range.lowerBound)
        let end = index(start, offsetBy: range.upperBound - range.lowerBound)
        return String(self[start ..< end])
    }
    
    var bool: Bool? {
        switch self.lowercased() {
        case "true", "t", "yes", "y", "1":
            return true
        case "false", "f", "no", "n", "0":
            return false
        default:
            return nil
        }
    }
}

extension String
{
    func trim() -> String
    {
        return self.trimmingCharacters(in: NSCharacterSet.whitespaces)
    }
}
